diff --git a/ent/src/yb/master/restore_sys_catalog_state.cc b/ent/src/yb/master/restore_sys_catalog_state.cc
index 6d463e51953a..9e8c486e7263 100644
--- a/ent/src/yb/master/restore_sys_catalog_state.cc
+++ b/ent/src/yb/master/restore_sys_catalog_state.cc
@@ -652,8 +652,7 @@ struct PgCatalogTableData {
   uint32_t pg_table_oid;
 
   CHECKED_STATUS SetTableId(const TableId& table_id) {
-    Uuid cotable_id;
-    RETURN_NOT_OK(cotable_id.FromHexString(table_id));
+    Uuid cotable_id = VERIFY_RESULT(Uuid::FromHexString(table_id));
     prefix[0] = docdb::KeyEntryTypeAsChar::kTableId;
     cotable_id.EncodeToComparable(&prefix[1]);
     pg_table_oid = VERIFY_RESULT(GetPgsqlTableOid(table_id));
diff --git a/ent/src/yb/tserver/twodc_write_implementations.cc b/ent/src/yb/tserver/twodc_write_implementations.cc
index 1dee03b926de..b6574b4f7db2 100644
--- a/ent/src/yb/tserver/twodc_write_implementations.cc
+++ b/ent/src/yb/tserver/twodc_write_implementations.cc
@@ -95,8 +95,7 @@ CHECKED_STATUS CombineExternalIntents(
 
   auto txn_id = VERIFY_RESULT(FullyDecodeTransactionId(transaction_state.transaction_id()));
   SCHECK_EQ(transaction_state.tablets().size(), 1, InvalidArgument, "Wrong tablets number");
-  Uuid status_tablet;
-  RETURN_NOT_OK(status_tablet.FromHexString(transaction_state.tablets()[0]));
+  auto status_tablet = VERIFY_RESULT(Uuid::FromHexString(transaction_state.tablets()[0]));
 
   Provider provider(status_tablet, &pairs, out->Add());
   docdb::CombineExternalIntents(txn_id, &provider);
diff --git a/src/yb/bfql/bfunc_convert.h b/src/yb/bfql/bfunc_convert.h
index fdaed2774e62..cc4a3c2d6770 100644
--- a/src/yb/bfql/bfunc_convert.h
+++ b/src/yb/bfql/bfunc_convert.h
@@ -984,9 +984,7 @@ CHECKED_STATUS ConvertBlobToUuid(PTypePtr source, RTypePtr target) {
     if (blob.size() != kSizeUuid) {
       return STATUS(QLError, "The blob string is not valid for UUID type.");
     }
-    Uuid target_val;
-    RETURN_NOT_OK(target_val.FromBytes(blob));
-    QLValue::set_uuid_value(target_val, &*target);
+    QLValue::set_uuid_value(VERIFY_RESULT(Uuid::FromSlice(blob)), &*target);
   }
   return Status::OK();
 }
@@ -1000,9 +998,7 @@ CHECKED_STATUS ConvertBlobToTimeuuid(PTypePtr source, RTypePtr target) {
     if (blob.size() != kSizeUuid) {
       return STATUS(QLError, "The blob string is not valid for UUID type.");
     }
-    Uuid target_val;
-    RETURN_NOT_OK(target_val.FromBytes(blob));
-    QLValue::set_timeuuid_value(target_val, &*target);
+    QLValue::set_timeuuid_value(VERIFY_RESULT(Uuid::FromSlice(blob)), &*target);
   }
   return Status::OK();
 }
diff --git a/src/yb/common/common_fwd.h b/src/yb/common/common_fwd.h
index af38c66dae81..b231f9ebf747 100644
--- a/src/yb/common/common_fwd.h
+++ b/src/yb/common/common_fwd.h
@@ -66,6 +66,7 @@ struct TransactionOperationContext;
 struct TransactionStatusResult;
 
 using ColocationId = uint32_t;
+using SchemaVersion = uint32_t;
 
 using QLTypePtr = std::shared_ptr<QLType>;
 
diff --git a/src/yb/common/constants.h b/src/yb/common/constants.h
index 0befbe02a05b..63a6de179e93 100644
--- a/src/yb/common/constants.h
+++ b/src/yb/common/constants.h
@@ -37,6 +37,9 @@ enum SortingType : uint8_t {
   kDescendingNullsLast // DESC, NULLS LAST
 };
 
+static const char* const kObsoleteShortPrimaryTableId = "sys.catalog.uuid";
+
+
 } // namespace yb
 
 #endif  // YB_COMMON_CONSTANTS_H
diff --git a/src/yb/common/ql_value.cc b/src/yb/common/ql_value.cc
index 81d2d0d7f79c..68e2ebf7cdce 100644
--- a/src/yb/common/ql_value.cc
+++ b/src/yb/common/ql_value.cc
@@ -374,16 +374,13 @@ Status QLValue::Deserialize(
     case UUID: {
       string bytes;
       RETURN_NOT_OK(CQLDecodeBytes(len, data, &bytes));
-      Uuid uuid;
-      RETURN_NOT_OK(uuid.FromBytes(bytes));
-      set_uuid_value(uuid);
+      set_uuid_value(VERIFY_RESULT(Uuid::FromSlice(bytes)));
       return Status::OK();
     }
     case TIMEUUID: {
       string bytes;
       RETURN_NOT_OK(CQLDecodeBytes(len, data, &bytes));
-      Uuid uuid;
-      RETURN_NOT_OK(uuid.FromBytes(bytes));
+      Uuid uuid = VERIFY_RESULT(Uuid::FromSlice(bytes));
       RETURN_NOT_OK(uuid.IsTimeUuid());
       set_timeuuid_value(uuid);
       return Status::OK();
@@ -704,29 +701,23 @@ InetAddress QLValue::inetaddress_value(const LWQLValuePB& pb) {
 }
 
 Uuid QLValue::timeuuid_value(const QLValuePB& pb) {
-  Uuid timeuuid;
-  CHECK_OK(timeuuid.FromBytes(timeuuid_value_pb(pb)));
+  Uuid timeuuid = CHECK_RESULT(Uuid::FromSlice(timeuuid_value_pb(pb)));
   CHECK_OK(timeuuid.IsTimeUuid());
   return timeuuid;
 }
 
 Uuid QLValue::timeuuid_value(const LWQLValuePB& pb) {
-  Uuid timeuuid;
-  CHECK_OK(timeuuid.FromSlice(timeuuid_value_pb(pb)));
+  Uuid timeuuid = CHECK_RESULT(Uuid::FromSlice(timeuuid_value_pb(pb)));
   CHECK_OK(timeuuid.IsTimeUuid());
   return timeuuid;
 }
 
 Uuid QLValue::uuid_value(const QLValuePB& pb) {
-  Uuid uuid;
-  CHECK_OK(uuid.FromBytes(uuid_value_pb(pb)));
-  return uuid;
+  return CHECK_RESULT(Uuid::FromSlice(uuid_value_pb(pb)));
 }
 
 Uuid QLValue::uuid_value(const LWQLValuePB& pb) {
-  Uuid uuid;
-  CHECK_OK(uuid.FromSlice(uuid_value_pb(pb)));
-  return uuid;
+  return CHECK_RESULT(Uuid::FromSlice(uuid_value_pb(pb)));
 }
 
 util::VarInt QLValue::varint_value(const QLValuePB& pb) {
diff --git a/src/yb/common/types.cc b/src/yb/common/types.cc
index 36874e1d4391..9b5d483ce18c 100644
--- a/src/yb/common/types.cc
+++ b/src/yb/common/types.cc
@@ -37,6 +37,7 @@
 #include "yb/gutil/singleton.h"
 
 #include "yb/util/net/inetaddress.h"
+#include "yb/util/result.h"
 #include "yb/util/status.h"
 #include "yb/util/uuid.h"
 
@@ -119,16 +120,12 @@ void DataTypeTraits<INET>::AppendDebugStringForValue(const void *val, std::strin
 
 void DataTypeTraits<UUID>::AppendDebugStringForValue(const void *val, std::string *str) {
   const Slice *s = reinterpret_cast<const Slice *>(val);
-  Uuid uuid;
-  DCHECK(uuid.FromSlice(*s).ok());
-  str->append(uuid.ToString());
+  str->append(CHECK_RESULT(Uuid::FromSlice(*s)).ToString());
 }
 
 void DataTypeTraits<TIMEUUID>::AppendDebugStringForValue(const void *val, std::string *str) {
   const Slice *s = reinterpret_cast<const Slice *>(val);
-  Uuid uuid;
-  DCHECK(uuid.FromSlice(*s).ok());
-  str->append(uuid.ToString());
+  str->append(CHECK_RESULT(Uuid::FromSlice(*s)).ToString());
 }
 
 } // namespace yb
diff --git a/src/yb/docdb/consensus_frontier-test.cc b/src/yb/docdb/consensus_frontier-test.cc
index 06a1dd0ef79b..9de68dd6a85f 100644
--- a/src/yb/docdb/consensus_frontier-test.cc
+++ b/src/yb/docdb/consensus_frontier-test.cc
@@ -32,7 +32,7 @@ std::string PbToString(const ConsensusFrontierPB& pb) {
   google::protobuf::Any any;
   any.PackFrom(pb);
   ConsensusFrontier frontier;
-  frontier.FromPB(any);
+  CHECK_OK(frontier.FromPB(any));
   return frontier.ToString();
 }
 
@@ -44,7 +44,8 @@ TEST_F(ConsensusFrontierTest, TestUpdates) {
     EXPECT_TRUE(frontier.Equals(frontier));
     EXPECT_EQ(
         "{ op_id: 0.0 hybrid_time: <invalid> history_cutoff: <invalid> "
-        "hybrid_time_filter: <invalid> max_value_level_ttl_expiration_time: <invalid> }",
+        "hybrid_time_filter: <invalid> max_value_level_ttl_expiration_time: <invalid> "
+        "primary_schema_version: <NULL> cotable_schema_versions: [] }",
         frontier.ToString());
     EXPECT_TRUE(frontier.IsUpdateValid(frontier, UpdateUserValueType::kLargest));
     EXPECT_TRUE(frontier.IsUpdateValid(frontier, UpdateUserValueType::kSmallest));
@@ -57,7 +58,8 @@ TEST_F(ConsensusFrontierTest, TestUpdates) {
     ConsensusFrontier frontier{{1, 1}, 1000_usec_ht, 500_usec_ht};
     EXPECT_EQ(
         "{ op_id: 1.1 hybrid_time: { physical: 1000 } history_cutoff: { physical: 500 } "
-        "hybrid_time_filter: <invalid> max_value_level_ttl_expiration_time: <invalid> }",
+        "hybrid_time_filter: <invalid> max_value_level_ttl_expiration_time: <invalid> "
+        "primary_schema_version: <NULL> cotable_schema_versions: [] }",
         frontier.ToString());
     ConsensusFrontier higher_idx{{1, 2}, 1000_usec_ht, 500_usec_ht};
     ConsensusFrontier higher_ht{{1, 1}, 1001_usec_ht, 500_usec_ht};
@@ -115,27 +117,31 @@ TEST_F(ConsensusFrontierTest, TestUpdates) {
   EXPECT_EQ(
       PbToString(pb),
       "{ op_id: 0.0 hybrid_time: <min> history_cutoff: <invalid> "
-      "hybrid_time_filter: <invalid> max_value_level_ttl_expiration_time: <invalid> }");
+      "hybrid_time_filter: <invalid> max_value_level_ttl_expiration_time: <invalid> "
+      "primary_schema_version: <NULL> cotable_schema_versions: [] }");
 
   pb.mutable_op_id()->set_term(2);
   pb.mutable_op_id()->set_index(3);
   EXPECT_EQ(
       PbToString(pb),
       "{ op_id: 2.3 hybrid_time: <min> history_cutoff: <invalid> "
-      "hybrid_time_filter: <invalid> max_value_level_ttl_expiration_time: <invalid> }");
+      "hybrid_time_filter: <invalid> max_value_level_ttl_expiration_time: <invalid> "
+      "primary_schema_version: <NULL> cotable_schema_versions: [] }");
 
   pb.set_hybrid_time(100000);
   EXPECT_EQ(
       PbToString(pb),
       "{ op_id: 2.3 hybrid_time: { physical: 24 logical: 1696 } history_cutoff: <invalid> "
-      "hybrid_time_filter: <invalid> max_value_level_ttl_expiration_time: <invalid> }");
+      "hybrid_time_filter: <invalid> max_value_level_ttl_expiration_time: <invalid> "
+      "primary_schema_version: <NULL> cotable_schema_versions: [] }");
 
   pb.set_history_cutoff(200000);
   EXPECT_EQ(
       PbToString(pb),
       "{ op_id: 2.3 hybrid_time: { physical: 24 logical: 1696 } "
       "history_cutoff: { physical: 48 logical: 3392 } "
-      "hybrid_time_filter: <invalid> max_value_level_ttl_expiration_time: <invalid> }");
+      "hybrid_time_filter: <invalid> max_value_level_ttl_expiration_time: <invalid> "
+      "primary_schema_version: <NULL> cotable_schema_versions: [] }");
 }
 
 TEST_F(ConsensusFrontierTest, TestUpdateExpirationTime) {
diff --git a/src/yb/docdb/consensus_frontier.cc b/src/yb/docdb/consensus_frontier.cc
index 3d4e00926d21..6a7171f68c64 100644
--- a/src/yb/docdb/consensus_frontier.cc
+++ b/src/yb/docdb/consensus_frontier.cc
@@ -16,22 +16,62 @@
 #include <google/protobuf/any.pb.h>
 
 #include "yb/docdb/docdb.pb.h"
+
 #include "yb/gutil/casts.h"
+#include "yb/gutil/stl_util.h"
+
 #include "yb/util/tostring.h"
 
 namespace yb {
 namespace docdb {
 
-ConsensusFrontier::~ConsensusFrontier() {
+namespace {
+
+template <class T>
+void MakeAtLeast(const T& other_value, T* this_value) {
+  this_value->MakeAtLeast(other_value);
+}
+
+template <class T>
+void MakeAtMost(const T& other_value, T* this_value) {
+  this_value->MakeAtMost(other_value);
+}
+
+template <class T>
+void MakeAtLeast(const std::optional<T>& other_value, std::optional<T>* this_value) {
+  if (other_value && (!*this_value || **this_value < *other_value)) {
+    *this_value = *other_value;
+  }
 }
 
+template <class T>
+void MakeAtMost(const std::optional<T>& other_value, std::optional<T>* this_value) {
+  if (other_value && (!*this_value || **this_value > *other_value)) {
+    *this_value = *other_value;
+  }
+}
+
+void MakeAtLeast(uint32_t other_value, uint32_t* this_value) {
+  *this_value = std::max(*this_value, other_value);
+}
+
+void MakeAtMost(uint32_t other_value, uint32_t* this_value) {
+  *this_value = std::min(*this_value, other_value);
+}
+
+} // namespace
+
+ConsensusFrontier::~ConsensusFrontier() = default;
+
 bool ConsensusFrontier::Equals(const UserFrontier& pre_rhs) const {
   const ConsensusFrontier& rhs = down_cast<const ConsensusFrontier&>(pre_rhs);
   return op_id_ == rhs.op_id_ &&
          hybrid_time_ == rhs.hybrid_time_ &&
          history_cutoff_ == rhs.history_cutoff_ &&
          hybrid_time_filter_ == rhs.hybrid_time_filter_ &&
-         max_value_level_ttl_expiration_time_ == rhs.max_value_level_ttl_expiration_time_;
+         max_value_level_ttl_expiration_time_ == rhs.max_value_level_ttl_expiration_time_ &&
+         primary_schema_version_ == rhs.primary_schema_version_ &&
+         cotable_schema_versions_ == rhs.cotable_schema_versions_;
 }
 
 void ConsensusFrontier::ToPB(google::protobuf::Any* any) const {
@@ -43,12 +83,20 @@ void ConsensusFrontier::ToPB(google::protobuf::Any* any) const {
     pb.set_hybrid_time_filter(hybrid_time_filter_.ToUint64());
   }
   pb.set_max_value_level_ttl_expiration_time(max_value_level_ttl_expiration_time_.ToUint64());
+  if (primary_schema_version_) {
+    AddTableSchemaVersion(Uuid::Nil(), *primary_schema_version_, &pb);
+  }
+  for (const auto& p : cotable_schema_versions_) {
+    AddTableSchemaVersion(p.first, p.second, &pb);
+  }
   any->PackFrom(pb);
 }
 
-void ConsensusFrontier::FromPB(const google::protobuf::Any& any) {
+Status ConsensusFrontier::FromPB(const google::protobuf::Any& any) {
   ConsensusFrontierPB pb;
-  any.UnpackTo(&pb);
+  if (!any.UnpackTo(&pb)) {
+    return STATUS(Corruption, "Unable to unpack consensus frontier");
+  }
   op_id_ = OpId::FromPB(pb.op_id());
   hybrid_time_ = HybridTime(pb.hybrid_time());
   history_cutoff_ = NormalizeHistoryCutoff(HybridTime(pb.history_cutoff()));
@@ -59,6 +107,15 @@ void ConsensusFrontier::FromPB(const google::protobuf::Any& any) {
   }
   max_value_level_ttl_expiration_time_ =
       HybridTime::FromPB(pb.max_value_level_ttl_expiration_time());
+  for (const auto& p : pb.table_schema_version()) {
+    if (p.table_id().empty()) {
+      primary_schema_version_ = p.schema_version();
+    } else {
+      cotable_schema_versions_.emplace(
+          VERIFY_RESULT(Uuid::FromSlice(p.table_id())), p.schema_version());
+    }
+  }
+  return Status::OK();
 }
 
 void ConsensusFrontier::FromOpIdPBDeprecated(const OpIdPB& pb) {
@@ -67,7 +124,8 @@ void ConsensusFrontier::FromOpIdPBDeprecated(const OpIdPB& pb) {
 
 std::string ConsensusFrontier::ToString() const {
   return YB_CLASS_TO_STRING(
-      op_id, hybrid_time, history_cutoff, hybrid_time_filter, max_value_level_ttl_expiration_time);
+      op_id, hybrid_time, history_cutoff, hybrid_time_filter, max_value_level_ttl_expiration_time,
+      primary_schema_version, cotable_schema_versions);
 }
 
 namespace {
@@ -96,10 +154,10 @@ void UpdateField(
     T* this_value, const T& new_value, rocksdb::UpdateUserValueType update_type) {
   switch (update_type) {
     case rocksdb::UpdateUserValueType::kLargest:
-      this_value->MakeAtLeast(new_value);
+      MakeAtLeast(new_value, this_value);
       return;
     case rocksdb::UpdateUserValueType::kSmallest:
-      this_value->MakeAtMost(new_value);
+      MakeAtMost(new_value, this_value);
       return;
   }
   FATAL_INVALID_ENUM_VALUE(rocksdb::UpdateUserValueType, update_type);
@@ -116,7 +174,16 @@ void ConsensusFrontier::Update(
   // Reset filter after compaction.
   hybrid_time_filter_ = HybridTime();
   UpdateField(&max_value_level_ttl_expiration_time_,
-      rhs.max_value_level_ttl_expiration_time_, update_type);
+              rhs.max_value_level_ttl_expiration_time_, update_type);
+  UpdateField(&primary_schema_version_, rhs.primary_schema_version_, update_type);
+  for (const auto& p : rhs.cotable_schema_versions_) {
+    auto it = cotable_schema_versions_.find(p.first);
+    if (it == cotable_schema_versions_.end()) {
+      cotable_schema_versions_.emplace(p);
+    } else {
+      UpdateField(&it->second, p.second, update_type);
+    }
+  }
 }
 
 Slice ConsensusFrontier::Filter() const {
@@ -136,5 +203,28 @@ bool ConsensusFrontier::IsUpdateValid(
          IsUpdateValidForField(hybrid_time_, rhs.hybrid_time_, update_type);
 }
 
+void ConsensusFrontier::AddSchemaVersion(const Uuid& table_id, SchemaVersion version) {
+  if (table_id.IsNil()) {
+    primary_schema_version_ = version;
+  } else {
+    cotable_schema_versions_[table_id] = version;
+  }
+}
+
+void ConsensusFrontier::ResetSchemaVersion() {
+  primary_schema_version_.reset();
+  cotable_schema_versions_.clear();
+}
+
+void ConsensusFrontier::MakeExternalSchemaVersionsAtMost(
+    std::unordered_map<Uuid, SchemaVersion, UuidHash>* min_schema_versions) const {
+  if (primary_schema_version_) {
+    yb::MakeAtMost(Uuid::Nil(), *primary_schema_version_, min_schema_versions);
+  }
+  for (const auto& p : cotable_schema_versions_) {
+    yb::MakeAtMost(p.first, p.second, min_schema_versions);
+  }
+}
+
 } // namespace docdb
 } // namespace yb
diff --git a/src/yb/docdb/consensus_frontier.h b/src/yb/docdb/consensus_frontier.h
index 8c074f7f385e..1cf5bb6c7c97 100644
--- a/src/yb/docdb/consensus_frontier.h
+++ b/src/yb/docdb/consensus_frontier.h
@@ -14,8 +14,15 @@
 #ifndef YB_DOCDB_CONSENSUS_FRONTIER_H
 #define YB_DOCDB_CONSENSUS_FRONTIER_H
 
+#include <unordered_map>
+
+#include "yb/common/common_fwd.h"
+#include "yb/common/entity_ids_types.h"
+
 #include "yb/rocksdb/metadata.h"
 
+#include "yb/util/uuid.h"
+
 namespace yb {
 namespace docdb {
 
@@ -49,7 +56,7 @@ class ConsensusFrontier : public rocksdb::UserFrontier {
   void Update(const rocksdb::UserFrontier& rhs, rocksdb::UpdateUserValueType type) override;
   bool IsUpdateValid(const rocksdb::UserFrontier& rhs, rocksdb::UpdateUserValueType type) const
       override;
-  void FromPB(const google::protobuf::Any& pb) override;
+  Status FromPB(const google::protobuf::Any& pb) override;
   void FromOpIdPBDeprecated(const OpIdPB& pb) override;
   Slice Filter() const override;
 
@@ -72,10 +79,20 @@ class ConsensusFrontier : public rocksdb::UserFrontier {
     hybrid_time_filter_ = value;
   }
 
-  HybridTime max_value_level_ttl_expiration_time() const
-      { return max_value_level_ttl_expiration_time_; }
-  void set_max_value_level_ttl_expiration_time(HybridTime ht)
-      { max_value_level_ttl_expiration_time_ = ht; }
+  void AddSchemaVersion(const Uuid& table_id, SchemaVersion version);
+  void ResetSchemaVersion();
+
+  // Merge current frontier with provided map, preferring min values.
+  void MakeExternalSchemaVersionsAtMost(
+      std::unordered_map<Uuid, SchemaVersion, UuidHash>* min_schema_versions) const;
+
+  HybridTime max_value_level_ttl_expiration_time() const {
+    return max_value_level_ttl_expiration_time_;
+  }
+
+  void set_max_value_level_ttl_expiration_time(HybridTime ht) {
+    max_value_level_ttl_expiration_time_ = ht;
+  }
 
  private:
   OpId op_id_;
@@ -92,6 +109,9 @@ class ConsensusFrontier : public rocksdb::UserFrontier {
   // TTL expiration (generated at write-time), table-level TTL is calculated at read-time based
   // on hybrid_time_. Only the largest frontier of this parameter is being used.
   HybridTime max_value_level_ttl_expiration_time_;
+
+  std::optional<SchemaVersion> primary_schema_version_;
+  std::unordered_map<Uuid, SchemaVersion, UuidHash> cotable_schema_versions_;
 };
 
 typedef rocksdb::UserFrontiersBase<ConsensusFrontier> ConsensusFrontiers;
@@ -110,6 +130,17 @@ inline void set_history_cutoff(HybridTime history_cutoff, ConsensusFrontiers* fr
   frontiers->Smallest().set_history_cutoff(history_cutoff);
   frontiers->Largest().set_history_cutoff(history_cutoff);
 }
+
+template <class PB>
+void AddTableSchemaVersion(
+    const Uuid& table_id, SchemaVersion schema_version, PB* pb) {
+  auto* out = pb->mutable_table_schema_version()->Add();
+  if (!table_id.IsNil()) {
+    out->set_table_id(table_id.cdata(), table_id.size());
+  }
+  out->set_schema_version(schema_version);
+}
+
 } // namespace docdb
 } // namespace yb
 
diff --git a/src/yb/docdb/doc_key-test.cc b/src/yb/docdb/doc_key-test.cc
index 0e5b822a41d1..879cbf1db0da 100644
--- a/src/yb/docdb/doc_key-test.cc
+++ b/src/yb/docdb/doc_key-test.cc
@@ -59,8 +59,7 @@ class DocKeyTest : public YBTest {
     const int kMaxNumRangeKeys = 3;
     const int kMaxNumSubKeys = 3;
     vector<SubDocKey> sub_doc_keys;
-    Uuid cotable_id;
-    EXPECT_OK(cotable_id.FromHexString("0123456789abcdef0123456789abcdef"));
+    auto cotable_id = CHECK_RESULT(Uuid::FromHexString("0123456789abcdef0123456789abcdef"));
 
     std::vector<std::pair<Uuid, ColocationId>> colocation_id_pairs;
     colocation_id_pairs.emplace_back(cotable_id, 0);
diff --git a/src/yb/docdb/doc_read_context.h b/src/yb/docdb/doc_read_context.h
index f88069c008b2..72ec7d558bc9 100644
--- a/src/yb/docdb/doc_read_context.h
+++ b/src/yb/docdb/doc_read_context.h
@@ -24,15 +24,19 @@ namespace docdb {
 struct DocReadContext {
   DocReadContext() = default;
 
-  DocReadContext(const Schema& schema_, uint32_t schema_version) : schema(schema_) {
+  DocReadContext(const Schema& schema_, SchemaVersion schema_version) : schema(schema_) {
     schema_packing_storage.AddSchema(schema_version, schema_);
   }
 
-  DocReadContext(const DocReadContext& rhs, const Schema& schema_, uint32_t schema_version)
+  DocReadContext(const DocReadContext& rhs, const Schema& schema_, SchemaVersion schema_version)
       : schema(schema_), schema_packing_storage(rhs.schema_packing_storage) {
     schema_packing_storage.AddSchema(schema_version, schema_);
   }
 
+  DocReadContext(const DocReadContext& rhs, SchemaVersion min_schema_version)
+      : schema(rhs.schema), schema_packing_storage(rhs.schema_packing_storage, min_schema_version) {
+  }
+
   template <class PB>
   CHECKED_STATUS LoadFromPB(const PB& pb) {
     RETURN_NOT_OK(SchemaFromPB(pb.schema(), &schema));
@@ -42,7 +46,7 @@ struct DocReadContext {
   }
 
   template <class PB>
-  void ToPB(uint32_t schema_version, PB* out) {
+  void ToPB(SchemaVersion schema_version, PB* out) {
     DCHECK(schema.has_column_ids());
     SchemaToPB(schema, out->mutable_schema());
     schema_packing_storage.ToPB(schema_version, out->mutable_old_schema_packings());
diff --git a/src/yb/docdb/docdb.cc b/src/yb/docdb/docdb.cc
index 2b14a85d700a..8539dd9f4251 100644
--- a/src/yb/docdb/docdb.cc
+++ b/src/yb/docdb/docdb.cc
@@ -353,8 +353,7 @@ CHECKED_STATUS PrepareApplyExternalIntentsBatch(
   auto input_value = original_input_value;
   DocHybridTimeBuffer doc_ht_buffer;
   RETURN_NOT_OK(input_value.consume_byte(KeyEntryTypeAsChar::kUuid));
-  Uuid status_tablet;
-  RETURN_NOT_OK(status_tablet.FromSlice(input_value.Prefix(kUuidSize)));
+  RETURN_NOT_OK(Uuid::FromSlice(input_value.Prefix(kUuidSize)));
   input_value.remove_prefix(kUuidSize);
   RETURN_NOT_OK(input_value.consume_byte(KeyEntryTypeAsChar::kExternalIntents));
   for (;;) {
diff --git a/src/yb/docdb/docdb.proto b/src/yb/docdb/docdb.proto
index 7b395f2f8f26..9634635ea5b2 100644
--- a/src/yb/docdb/docdb.proto
+++ b/src/yb/docdb/docdb.proto
@@ -31,6 +31,11 @@ message ApplyExternalTransactionPB {
   optional fixed64 commit_hybrid_time = 2;
 }
 
+message TableSchemaVersionPB {
+  optional bytes table_id = 1;
+  optional uint32 schema_version = 2;
+}
+
 // A set of key/value pairs to be written into RocksDB.
 message KeyValueWriteBatchPB {
   repeated KeyValuePairPB write_pairs = 1;
@@ -48,6 +53,10 @@ message KeyValueWriteBatchPB {
   repeated ApplyExternalTransactionPB apply_external_transactions = 7;
 
   optional int64 ttl = 9;
+
+  // Table schema version used by this write batch.
+  // We could have writes to multiple cotables in a single write batch.
+  repeated TableSchemaVersionPB table_schema_version = 11;
 }
 
 message ConsensusFrontierPB {
@@ -56,6 +65,7 @@ message ConsensusFrontierPB {
   optional fixed64 history_cutoff = 3;
   optional fixed64 hybrid_time_filter = 4;
   optional fixed64 max_value_level_ttl_expiration_time = 5;
+  repeated TableSchemaVersionPB table_schema_version = 6;
 }
 
 message ApplyTransactionStatePB {
diff --git a/src/yb/docdb/docdb_compaction_context.cc b/src/yb/docdb/docdb_compaction_context.cc
index 0480b6896225..eef53350ba25 100644
--- a/src/yb/docdb/docdb_compaction_context.cc
+++ b/src/yb/docdb/docdb_compaction_context.cc
@@ -51,6 +51,11 @@ struct OverwriteData {
   }
 };
 
+Result<SchemaVersion> ParseValueHeader(Slice* value) {
+  value->consume_byte(); // TODO(packed_row) control_fields
+  return narrow_cast<SchemaVersion>(VERIFY_RESULT(util::FastDecodeUnsignedVarInt(value)));
+}
+
 struct PackedRowData {
   rocksdb::CompactionFeed& next_feed;
   SchemaPackingProvider schema_packing_provider;
@@ -59,23 +64,60 @@ struct PackedRowData {
   KeyBuffer key;
   DocHybridTime ht;
   uint64_t last_internal_component;
+
+  // All old_ fields are releated to original row packing.
+  // I.e. row state that had place before the compaction.
   ValueBuffer old_value;
   Slice old_value_slice;
+  SchemaVersion old_schema_version;
+  CompactionSchemaPacking old_packing;
 
-  bool repacking; // Are we started repacking the row.
+  bool repacking; // Whether we have started repacking the row.
   Uuid active_cotable_id;
-  CompactionSchemaPacking old_packing;
   CompactionSchemaPacking new_packing;
   boost::optional<RowPacker> packer;
 
+  // Schema version ranges for each found table.
+  // That could be a surprise, but when we are talking about range and use pair to represent range
+  // first usually means min value of the range, while second means max value of the range.
+  std::unordered_map<Uuid, std::pair<SchemaVersion, SchemaVersion>, UuidHash> used_schema_versions;
+
   PackedRowData(rocksdb::CompactionFeed* next_feed_, const SchemaPackingProvider& provider)
-      : next_feed(*next_feed_), schema_packing_provider(provider) {
+      : next_feed(*next_feed_), schema_packing_provider(provider),
+        // Use fake cotable id as default value.
+        // So we will trigger table change on the first record.
+        // The initial cotable id value does not matter, so we could pick random one.
+        active_cotable_id(CHECK_RESULT(Uuid::FromString("aad942d6-b0c7-41ca-b2b9-e6d809a8675f"))) {
   }
 
   bool active() const {
     return !key.empty();
   }
 
+  Status UpdateMeta(rocksdb::FileMetaData* meta) {
+    if (!meta->smallest.user_frontier || !meta->largest.user_frontier) {
+      // Relevant in tests only.
+      return Status::OK();
+    }
+    auto& smallest = down_cast<ConsensusFrontier&>(*meta->smallest.user_frontier);
+    smallest.ResetSchemaVersion();
+    auto& largest = down_cast<ConsensusFrontier&>(*meta->largest.user_frontier);
+    largest.ResetSchemaVersion();
+    for (const auto& p : used_schema_versions) {
+      smallest.AddSchemaVersion(p.first, p.second.first);
+      largest.AddSchemaVersion(p.first, p.second.second);
+    }
+    return Status::OK();
+  }
+
+  // Handle packed row that was forwarded to underlying feed w/o changes.
+  Status ProcessForwardedPackedRow(const Slice& internal_key, Slice value) {
+    Uuid cotable_id = Uuid::Nil(); // TODO(packed_row) Decode cotable_id
+    auto schema_version = VERIFY_RESULT(ParseValueHeader(&value));
+    UsedSchemaVersion(cotable_id, schema_version);
+    return Status::OK();
+  }
+
   Status ProcessPackedRow(
       const Slice& internal_key, size_t doc_key_size, const ValueControlFields& row_control_fields,
       const Slice& value, const DocHybridTime& row_doc_ht) {
@@ -89,6 +131,20 @@ struct PackedRowData {
         sizeof(last_internal_component));
     old_value.Assign(value);
     old_value_slice = old_value.AsSlice();
+    old_schema_version = VERIFY_RESULT(ParseValueHeader(&old_value_slice));
+    Uuid cotable_id = Uuid::Nil(); // TODO(packed_row) Decode cotable_id
+    auto table_changed = active_cotable_id != cotable_id;
+    if (table_changed) {
+      new_packing = VERIFY_RESULT(schema_packing_provider(
+          cotable_id, /* schema_version = */ std::numeric_limits<SchemaVersion>::max()));
+      UsedSchemaVersion(cotable_id, new_packing.schema_version);
+      old_packing.schema_version = std::numeric_limits<SchemaVersion>::max();
+      packer.reset();
+      active_cotable_id = cotable_id;
+    }
+    if (old_schema_version != new_packing.schema_version) {
+      return StartRepacking();
+    }
     repacking = false;
     return Status::OK();
   }
@@ -118,20 +174,12 @@ struct PackedRowData {
   }
 
   Status StartRepacking() {
-    Uuid cotable_id = Uuid::Nil(); // TODO(packed_row) !!!
-    repacking = true;
-    old_value_slice.consume_byte(); // TODO(packed_row) control_fields
-    auto old_schema_version = narrow_cast<uint32_t>(
-        VERIFY_RESULT(util::FastDecodeUnsignedVarInt(&old_value_slice)));
-    auto table_changed = active_cotable_id != cotable_id;
-    if (old_schema_version != old_packing.schema_version || table_changed) {
-      old_packing = VERIFY_RESULT(schema_packing_provider(cotable_id, old_schema_version));
+    if (old_schema_version != old_packing.schema_version) {
+      old_packing = VERIFY_RESULT(schema_packing_provider(active_cotable_id, old_schema_version));
     }
-    if (!packer || table_changed) {
-      new_packing = VERIFY_RESULT(schema_packing_provider(
-          cotable_id, /* schema_version = */ std::numeric_limits<uint32_t>::max()));
+    repacking = true;
+    if (!packer) {
       packer.emplace(new_packing.schema_version, *new_packing.schema_packing);
-      active_cotable_id = cotable_id;
     } else {
       packer->Restart();
     }
@@ -179,6 +227,16 @@ struct PackedRowData {
     VLOG(4) << "Keep value: " << column_value->ToDebugHexString();
     return packer->AddValue(column_id, *column_value);
   }
+
+  void UsedSchemaVersion(const Uuid& cotable_id, SchemaVersion version) {
+    auto it = used_schema_versions.find(cotable_id);
+    if (it == used_schema_versions.end()) {
+      used_schema_versions.emplace(cotable_id, std::make_pair(version, version));
+    } else {
+      it->second.first = std::min(it->second.first, version);
+      it->second.second = std::max(it->second.second, version);
+    }
+  }
 };
 
 class DocDBCompactionFeed : public rocksdb::CompactionFeed {
@@ -196,6 +254,10 @@ class DocDBCompactionFeed : public rocksdb::CompactionFeed {
 
   Status Feed(const Slice& internal_key, const Slice& value) override;
 
+  Status UpdateMeta(rocksdb::FileMetaData* meta) {
+    return packed_row_.UpdateMeta(meta);
+  }
+
   Status PassToNextFeed(const Slice& key, const Slice& value) {
     RETURN_NOT_OK(packed_row_.Flush());
     return next_feed_.Feed(key, value);
@@ -408,6 +470,12 @@ Status DocDBCompactionFeed::Feed(const Slice& internal_key, const Slice& value)
     overwrite_.push_back({prev_overwrite_ht, prev_exp});
     VLOG_WITH_FUNC(4)
         << "Feed to next because of history cutoff: " << ht.hybrid_time() << ", " << history_cutoff;
+    auto value_slice = value;
+    RETURN_NOT_OK(ValueControlFields::Decode(&value_slice));
+    if (DecodeValueEntryType(value_slice) == ValueEntryType::kPackedRow) {
+      // Check packed row version for rows left untouched.
+      RETURN_NOT_OK(packed_row_.ProcessForwardedPackedRow(internal_key, value_slice));
+    }
     return PassToNextFeed(internal_key, value);
   }
 
@@ -494,7 +562,7 @@ Status DocDBCompactionFeed::Feed(const Slice& internal_key, const Slice& value)
         "Double packed rows: $0, $1", packed_row_.key.AsSlice().ToDebugHexString(),
         internal_key.ToDebugHexString()));
     return packed_row_.ProcessPackedRow(
-        internal_key, sub_key_ends_.back(), control_fields, value, ht);
+        internal_key, sub_key_ends_.back(), control_fields, value_slice, ht);
   }
 
   // If the entry has the TTL flag, delete the entry.
@@ -564,7 +632,49 @@ void DocDBCompactionFeed::AssignPrevSubDocKey(
   memcpy(prev_subdoc_key_.data() + same_bytes, data + same_bytes, size - same_bytes);
 }
 
-} // namespace
+// DocDB compaction feed. A new instance of this class is created for every compaction.
+class DocDBCompactionContext : public rocksdb::CompactionContext {
+ public:
+  DocDBCompactionContext(
+      rocksdb::CompactionFeed* next_feed,
+      HistoryRetentionDirective retention,
+      IsMajorCompaction is_major_compaction,
+      const KeyBounds* key_bounds,
+      const SchemaPackingProvider& schema_packing_provider);
+
+  ~DocDBCompactionContext() = default;
+
+  rocksdb::CompactionFeed* Feed() override {
+    return feed_.get();
+  }
+
+  // This indicates we don't have a cached TTL. We need this to be different from kMaxTtl
+  // and kResetTtl because a PERSIST call would lead to a cached TTL of kMaxTtl, and kResetTtl
+  // indicates no TTL in Cassandra.
+  const MonoDelta kNoTtl = MonoDelta::FromNanoseconds(-1);
+
+  // This is used to provide the history_cutoff timestamp to the compaction as a field in the
+  // ConsensusFrontier, so that it can be persisted in RocksDB metadata and recovered on bootstrap.
+  rocksdb::UserFrontierPtr GetLargestUserFrontier() const override;
+
+  // Returns an empty list when key_ranges_ is not set, denoting that the whole key range of the
+  // tablet should be considered live.
+  //
+  // When key_ranges_ is set, returns two live ranges:
+  // (1) A range covering any ApplyTransactionState records which may have been written
+  // (2) A range covering all valid keys in key_ranges_, i.e. all user data this tablet is
+  //     responsible for.
+  std::vector<std::pair<Slice, Slice>> GetLiveRanges() const override;
+
+  Status UpdateMeta(rocksdb::FileMetaData* meta) override {
+    return feed_->UpdateMeta(meta);
+  }
+
+ private:
+  HybridTime history_cutoff_;
+  const KeyBounds* key_bounds_;
+  std::unique_ptr<DocDBCompactionFeed> feed_;
+};
 
 DocDBCompactionContext::DocDBCompactionContext(
     rocksdb::CompactionFeed* next_feed,
@@ -601,6 +711,8 @@ std::vector<std::pair<Slice, Slice>> DocDBCompactionContext::GetLiveRanges() con
   return {first_range, second_range};
 }
 
+} // namespace
+
 // ------------------------------------------------------------------------------------------------
 
 std::shared_ptr<rocksdb::CompactionContextFactory> CreateCompactionContextFactory(
diff --git a/src/yb/docdb/docdb_compaction_context.h b/src/yb/docdb/docdb_compaction_context.h
index 276d49eb4565..24020901d338 100644
--- a/src/yb/docdb/docdb_compaction_context.h
+++ b/src/yb/docdb/docdb_compaction_context.h
@@ -72,46 +72,6 @@ struct CompactionSchemaPacking {
 using SchemaPackingProvider = std::function<
     Result<CompactionSchemaPacking>(const Uuid& table_id, uint32_t schema_version)>;
 
-// DocDB compaction feed. A new instance of this class is created for every compaction.
-class DocDBCompactionContext : public rocksdb::CompactionContext {
- public:
-  DocDBCompactionContext(
-      rocksdb::CompactionFeed* next_feed,
-      HistoryRetentionDirective retention,
-      IsMajorCompaction is_major_compaction,
-      const KeyBounds* key_bounds,
-      const SchemaPackingProvider& schema_packing_provider);
-
-  ~DocDBCompactionContext() = default;
-
-  rocksdb::CompactionFeed* Feed() override {
-    return feed_.get();
-  }
-
-  // This indicates we don't have a cached TTL. We need this to be different from kMaxTtl
-  // and kResetTtl because a PERSIST call would lead to a cached TTL of kMaxTtl, and kResetTtl
-  // indicates no TTL in Cassandra.
-  const MonoDelta kNoTtl = MonoDelta::FromNanoseconds(-1);
-
-  // This is used to provide the history_cutoff timestamp to the compaction as a field in the
-  // ConsensusFrontier, so that it can be persisted in RocksDB metadata and recovered on bootstrap.
-  rocksdb::UserFrontierPtr GetLargestUserFrontier() const override;
-
-  // Returns an empty list when key_ranges_ is not set, denoting that the whole key range of the
-  // tablet should be considered live.
-  //
-  // When key_ranges_ is set, returns two live ranges:
-  // (1) A range covering any ApplyTransactionState records which may have been written
-  // (2) A range covering all valid keys in key_ranges_, i.e. all user data this tablet is
-  //     responsible for.
-  std::vector<std::pair<Slice, Slice>> GetLiveRanges() const override;
-
- private:
-  HybridTime history_cutoff_;
-  const KeyBounds* key_bounds_;
-  std::unique_ptr<rocksdb::CompactionFeed> feed_;
-};
-
 // A strategy for deciding how the history of old database operations should be retained during
 // compactions. We may implement this differently in production and in tests.
 class HistoryRetentionPolicy {
diff --git a/src/yb/docdb/kv_debug.cc b/src/yb/docdb/kv_debug.cc
index a8a1ce8893b4..4f7cc601bdb8 100644
--- a/src/yb/docdb/kv_debug.cc
+++ b/src/yb/docdb/kv_debug.cc
@@ -164,8 +164,7 @@ Result<std::string> DocDBValueToDebugStr(
       std::vector<std::string> intents;
       SubDocKey sub_doc_key;
       RETURN_NOT_OK(value.consume_byte(ValueEntryTypeAsChar::kUuid));
-      Uuid involved_tablet;
-      RETURN_NOT_OK(involved_tablet.FromSlice(value.Prefix(kUuidSize)));
+      auto involved_tablet = VERIFY_RESULT(Uuid::FromSlice(value.Prefix(kUuidSize)));
       value.remove_prefix(kUuidSize);
       RETURN_NOT_OK(value.consume_byte(KeyEntryTypeAsChar::kExternalIntents));
       for (;;) {
diff --git a/src/yb/docdb/packed_row.cc b/src/yb/docdb/packed_row.cc
index b1273f45b8f9..9aa3fb4a9aac 100644
--- a/src/yb/docdb/packed_row.cc
+++ b/src/yb/docdb/packed_row.cc
@@ -136,7 +136,17 @@ void SchemaPacking::ToPB(SchemaPackingPB* out) const {
 
 SchemaPackingStorage::SchemaPackingStorage() = default;
 
-Result<const SchemaPacking&> SchemaPackingStorage::GetPacking(uint32_t schema_version) const {
+SchemaPackingStorage::SchemaPackingStorage(
+    const SchemaPackingStorage& rhs, SchemaVersion min_schema_version) {
+  for (const auto& [version, packing] : rhs.version_to_schema_packing_) {
+    if (version < min_schema_version) {
+      continue;
+    }
+    version_to_schema_packing_.emplace(version, packing);
+  }
+}
+
+Result<const SchemaPacking&> SchemaPackingStorage::GetPacking(SchemaVersion schema_version) const {
   auto it = version_to_schema_packing_.find(schema_version);
   if (it == version_to_schema_packing_.end()) {
     return STATUS_FORMAT(NotFound, "Schema packing not found: $0", schema_version);
@@ -146,10 +156,10 @@ Result<const SchemaPacking&> SchemaPackingStorage::GetPacking(uint32_t schema_ve
 
 Result<const SchemaPacking&> SchemaPackingStorage::GetPacking(Slice* packed_row) const {
   auto version = VERIFY_RESULT(util::FastDecodeUnsignedVarInt(packed_row));
-  return GetPacking(narrow_cast<uint32_t>(version));
+  return GetPacking(narrow_cast<SchemaVersion>(version));
 }
 
-void SchemaPackingStorage::AddSchema(uint32_t version, const Schema& schema) {
+void SchemaPackingStorage::AddSchema(SchemaVersion version, const Schema& schema) {
   auto inserted = version_to_schema_packing_.emplace(
       std::piecewise_construct,
       std::forward_as_tuple(version),
@@ -173,7 +183,7 @@ Status SchemaPackingStorage::LoadFromPB(
 }
 
 void SchemaPackingStorage::ToPB(
-    uint32_t skip_schema_version, google::protobuf::RepeatedPtrField<SchemaPackingPB>* out) {
+    SchemaVersion skip_schema_version, google::protobuf::RepeatedPtrField<SchemaPackingPB>* out) {
   for (const auto& version_and_packing : version_to_schema_packing_) {
     if (version_and_packing.first == skip_schema_version) {
       continue;;
@@ -184,7 +194,16 @@ void SchemaPackingStorage::ToPB(
   }
 }
 
-RowPacker::RowPacker(uint32_t version, std::reference_wrapper<const SchemaPacking> packing)
+bool SchemaPackingStorage::HasVersionBelow(SchemaVersion version) const {
+  for (const auto& p : version_to_schema_packing_) {
+    if (p.first < version) {
+      return true;
+    }
+  }
+  return false;
+}
+
+RowPacker::RowPacker(SchemaVersion version, std::reference_wrapper<const SchemaPacking> packing)
     : packing_(packing) {
   size_t prefix_len = packing_.prefix_len();
   result_.Reserve(1 + kMaxVarint32Length + prefix_len);
diff --git a/src/yb/docdb/packed_row.h b/src/yb/docdb/packed_row.h
index 2005a4b7ac27..5ec96ada371c 100644
--- a/src/yb/docdb/packed_row.h
+++ b/src/yb/docdb/packed_row.h
@@ -129,23 +129,34 @@ class SchemaPacking {
 class SchemaPackingStorage {
  public:
   SchemaPackingStorage();
+  explicit SchemaPackingStorage(const SchemaPackingStorage& rhs, SchemaVersion min_schema_version);
 
-  Result<const SchemaPacking&> GetPacking(uint32_t schema_version) const;
+  Result<const SchemaPacking&> GetPacking(SchemaVersion schema_version) const;
   Result<const SchemaPacking&> GetPacking(Slice* packed_row) const;
 
-  void AddSchema(uint32_t version, const Schema& schema);
+  void AddSchema(SchemaVersion version, const Schema& schema);
 
   CHECKED_STATUS LoadFromPB(const google::protobuf::RepeatedPtrField<SchemaPackingPB>& schemas);
-  void ToPB(uint32_t skip_schema_version, google::protobuf::RepeatedPtrField<SchemaPackingPB>* out);
+
+  // Copy all schema packings except schema_version_to_skip to out.
+  void ToPB(
+      SchemaVersion schema_version_to_skip,
+      google::protobuf::RepeatedPtrField<SchemaPackingPB>* out);
+
+  size_t SchemaCount() const {
+    return version_to_schema_packing_.size();
+  }
+
+  bool HasVersionBelow(SchemaVersion version) const;
 
  private:
-  std::unordered_map<uint32_t, SchemaPacking> version_to_schema_packing_;
+  std::unordered_map<SchemaVersion, SchemaPacking> version_to_schema_packing_;
 };
 
 class RowPacker {
  public:
-  RowPacker(uint32_t version, std::reference_wrapper<const SchemaPacking> packing);
-  explicit RowPacker(const std::pair<uint32_t, const SchemaPacking&>& pair)
+  RowPacker(SchemaVersion version, std::reference_wrapper<const SchemaPacking> packing);
+  explicit RowPacker(const std::pair<SchemaVersion, const SchemaPacking&>& pair)
       : RowPacker(pair.first, pair.second) {
   }
 
diff --git a/src/yb/docdb/primitive_value.cc b/src/yb/docdb/primitive_value.cc
index 40eca2d815e5..0be7e6bebd42 100644
--- a/src/yb/docdb/primitive_value.cc
+++ b/src/yb/docdb/primitive_value.cc
@@ -933,8 +933,8 @@ Status KeyEntryValue::DecodeKey(Slice* slice, KeyEntryValue* out) {
         return STATUS_FORMAT(Corruption, "Not enough bytes for UUID: $0", slice->size());
       }
       if (out) {
-        RETURN_NOT_OK((new(&out->uuid_val_) Uuid())->FromSlice(
-            *slice, boost::uuids::uuid::static_size()));
+        out->uuid_val_ = VERIFY_RESULT(Uuid::FromSlice(
+            slice->Prefix(boost::uuids::uuid::static_size())));
       }
       slice->remove_prefix(boost::uuids::uuid::static_size());
       type_ref = type;
diff --git a/src/yb/gutil/stl_util.h b/src/yb/gutil/stl_util.h
index f26c1d8838de..f9545c1677bc 100644
--- a/src/yb/gutil/stl_util.h
+++ b/src/yb/gutil/stl_util.h
@@ -1021,6 +1021,16 @@ void Unique(Collection* collection) {
   collection->erase(std::unique(collection->begin(), collection->end()), collection->end());
 }
 
+template <class Key, class Value, class Map>
+void MakeAtMost(const Key& key, const Value& value, Map* map) {
+  auto it = map->find(key);
+  if (it == map->end()) {
+    map->emplace(key, value);
+  } else {
+    it->second = std::min(it->second, value);
+  }
+}
+
 } // namespace yb
 
 // For backward compatibility
diff --git a/src/yb/master/catalog_manager.cc b/src/yb/master/catalog_manager.cc
index 3fa38002a2bb..f6c4843321ea 100644
--- a/src/yb/master/catalog_manager.cc
+++ b/src/yb/master/catalog_manager.cc
@@ -5536,9 +5536,7 @@ CHECKED_STATUS ApplyAlterSteps(server::Clock* clock,
   }
   if (current_pb.has_colocated() && current_pb.colocated()) {
     if (current_schema_pb.table_properties().is_ysql_catalog_table()) {
-      Uuid cotable_id;
-      RETURN_NOT_OK(cotable_id.FromHexString(req->table().table_id()));
-      builder.set_cotable_id(cotable_id);
+      builder.set_cotable_id(VERIFY_RESULT(Uuid::FromHexString(req->table().table_id())));
     }
     // Colocation ID is set in schema and cannot be altered.
   }
diff --git a/src/yb/master/sys_catalog.cc b/src/yb/master/sys_catalog.cc
index 503c5b10aab4..957a19588ef6 100644
--- a/src/yb/master/sys_catalog.cc
+++ b/src/yb/master/sys_catalog.cc
@@ -324,8 +324,8 @@ Status SysCatalogTable::CreateNew(FsManager *fs_manager) {
   DCHECK_EQ(1, partitions.size());
 
   auto table_info = std::make_shared<tablet::TableInfo>(
-      kSysCatalogTableId, "", table_name(), TableType::YQL_TABLE_TYPE, schema, IndexMap(),
-      boost::none /* index_info */, 0 /* schema_version */, partition_schema);
+      tablet::Primary::kTrue, kSysCatalogTableId, "", table_name(), TableType::YQL_TABLE_TYPE,
+      schema, IndexMap(), boost::none /* index_info */, 0 /* schema_version */, partition_schema);
   string data_root_dir = fs_manager->GetDataRootDirs()[0];
   fs_manager->SetTabletPathByDataPath(kSysCatalogTabletId, data_root_dir);
   auto metadata = VERIFY_RESULT(tablet::RaftGroupMetadata::CreateNew(tablet::RaftGroupMetadataData {
diff --git a/src/yb/master/sys_catalog_constants.h b/src/yb/master/sys_catalog_constants.h
index 11473a705865..2787eabd7d0d 100644
--- a/src/yb/master/sys_catalog_constants.h
+++ b/src/yb/master/sys_catalog_constants.h
@@ -32,11 +32,13 @@
 #ifndef YB_MASTER_SYS_CATALOG_CONSTANTS_H_
 #define YB_MASTER_SYS_CATALOG_CONSTANTS_H_
 
+#include "yb/common/constants.h"
+
 namespace yb {
 namespace master {
 
 static const char* const kSysCatalogTabletId = "00000000000000000000000000000000";
-static const char* const kSysCatalogTableId = "sys.catalog.uuid";
+static const char* const kSysCatalogTableId = kObsoleteShortPrimaryTableId;
 static const char* const kSysCatalogTableName = "sys.catalog";
 static const char* const kSysCatalogTableColType = "entry_type";
 static const char* const kSysCatalogTableColId = "entry_id";
diff --git a/src/yb/master/yql_indexes_vtable.cc b/src/yb/master/yql_indexes_vtable.cc
index 4d5169307407..5c9d1e3add94 100644
--- a/src/yb/master/yql_indexes_vtable.cc
+++ b/src/yb/master/yql_indexes_vtable.cc
@@ -190,11 +190,10 @@ Result<std::shared_ptr<QLRowBlock>> YQLIndexesVTable::RetrieveData(
     RETURN_NOT_OK(SetColumnValue(kOptions, options.value(), &row));
 
     // Create appropriate table uuids.
-    Uuid uuid;
     // Note: table id is in host byte order.
-    RETURN_NOT_OK(uuid.FromHexString(indexed_table_id));
+    auto uuid = VERIFY_RESULT(Uuid::FromHexString(indexed_table_id));
     RETURN_NOT_OK(SetColumnValue(kTableId, uuid, &row));
-    RETURN_NOT_OK(uuid.FromHexString(table->id()));
+    uuid = VERIFY_RESULT(Uuid::FromHexString(table->id()));
     RETURN_NOT_OK(SetColumnValue(kIndexId, uuid, &row));
 
     Schema schema;
diff --git a/src/yb/master/yql_local_vtable.cc b/src/yb/master/yql_local_vtable.cc
index 58bb3ad2b740..82c0cf55f76e 100644
--- a/src/yb/master/yql_local_vtable.cc
+++ b/src/yb/master/yql_local_vtable.cc
@@ -117,8 +117,8 @@ Result<std::shared_ptr<QLRowBlock>> LocalVTable::RetrieveData(
     RETURN_NOT_OK(SetColumnValue(kSystemLocalDataCenterColumn, cloud_info.placement_region(),
                                  &row));
     RETURN_NOT_OK(SetColumnValue(kSystemLocalGossipGenerationColumn, 0, &row));
-    Uuid host_id;
-    RETURN_NOT_OK(host_id.FromHexString(entry.ts_info.tserver_instance().permanent_uuid()));
+    auto host_id = VERIFY_RESULT(Uuid::FromHexString(
+        entry.ts_info.tserver_instance().permanent_uuid()));
     RETURN_NOT_OK(SetColumnValue(kSystemLocalHostIdColumn, host_id, &row));
     RETURN_NOT_OK(SetColumnValue(kSystemLocalListenAddressColumn, private_ip, &row));
     RETURN_NOT_OK(SetColumnValue(kSystemLocalNativeProtocolVersionColumn, "4", &row));
diff --git a/src/yb/master/yql_partitions_vtable.cc b/src/yb/master/yql_partitions_vtable.cc
index 581964131883..ec9858b3a77f 100644
--- a/src/yb/master/yql_partitions_vtable.cc
+++ b/src/yb/master/yql_partitions_vtable.cc
@@ -236,8 +236,7 @@ Status YQLPartitionsVTable::InsertTabletIntoRowUnlocked(
   RETURN_NOT_OK(SetColumnValue(kEndKey, partition.partition_key_end(), row));
 
   // Note: tablet id is in host byte order.
-  Uuid uuid;
-  RETURN_NOT_OK(uuid.FromHexString(tablet.tablet_id));
+  auto uuid = VERIFY_RESULT(Uuid::FromHexString(tablet.tablet_id));
   RETURN_NOT_OK(SetColumnValue(kId, uuid, row));
 
   // Get replicas for tablet.
diff --git a/src/yb/master/yql_peers_vtable.cc b/src/yb/master/yql_peers_vtable.cc
index af97449b7a90..1e97975ade94 100644
--- a/src/yb/master/yql_peers_vtable.cc
+++ b/src/yb/master/yql_peers_vtable.cc
@@ -140,8 +140,8 @@ Result<std::shared_ptr<QLRowBlock>> PeersVTable::RetrieveData(
     RETURN_NOT_OK(SetColumnValue(kRack, cloud_info.placement_zone(), &row));
 
     // HostId.
-    Uuid host_id;
-    RETURN_NOT_OK(host_id.FromHexString(entry.ts_info.tserver_instance().permanent_uuid()));
+    auto host_id = VERIFY_RESULT(Uuid::FromHexString(
+        entry.ts_info.tserver_instance().permanent_uuid()));
     RETURN_NOT_OK(SetColumnValue(kHostId, host_id, &row));
     RETURN_NOT_OK(SetColumnValue(yb::master::kSystemTablesReleaseVersionColumn,
         yb::master::kSystemTablesReleaseVersion, &row));
diff --git a/src/yb/master/yql_tables_vtable.cc b/src/yb/master/yql_tables_vtable.cc
index 6e1017de65ca..2c4b8992aba2 100644
--- a/src/yb/master/yql_tables_vtable.cc
+++ b/src/yb/master/yql_tables_vtable.cc
@@ -63,9 +63,8 @@ Result<std::shared_ptr<QLRowBlock>> YQLTablesVTable::RetrieveData(
     RETURN_NOT_OK(SetColumnValue(kFlags, flags_set, &row));
 
     // Create appropriate table uuid entry.
-    Uuid uuid;
     // Note: table id is in host byte order.
-    RETURN_NOT_OK(uuid.FromHexString(table->id()));
+    auto uuid = VERIFY_RESULT(Uuid::FromHexString(table->id()));
     RETURN_NOT_OK(SetColumnValue(kId, uuid, &row));
 
     // Set the values for the table properties.
diff --git a/src/yb/rocksdb/db/compaction_context.h b/src/yb/rocksdb/db/compaction_context.h
index 6b8b7b1098de..e2df3184fcdb 100644
--- a/src/yb/rocksdb/db/compaction_context.h
+++ b/src/yb/rocksdb/db/compaction_context.h
@@ -50,6 +50,9 @@ class CompactionContext {
   // represented as pairs of Slices denoting the beginning and end of the range in user space.
   virtual std::vector<std::pair<Slice, Slice>> GetLiveRanges() const = 0;
 
+  // Update file meta data after compaction. For instance could be used to patch frontiers.
+  virtual Status UpdateMeta(FileMetaData* meta) = 0;
+
   virtual ~CompactionContext() = default;
 };
 
diff --git a/src/yb/rocksdb/db/compaction_job.cc b/src/yb/rocksdb/db/compaction_job.cc
index 85ce675a0dfc..5d2fc920667e 100644
--- a/src/yb/rocksdb/db/compaction_job.cc
+++ b/src/yb/rocksdb/db/compaction_job.cc
@@ -814,9 +814,12 @@ Status CompactionJob::FinishCompactionOutputFile(
   TableProperties table_properties;
   // Check for iterator errors
   Status s = input_status;
-  auto meta = &sub_compact->current_output()->meta;
+  auto& meta = sub_compact->current_output()->meta;
   const uint64_t current_entries = sub_compact->builder->NumEntries();
-  meta->marked_for_compaction = sub_compact->builder->NeedCompact();
+  meta.marked_for_compaction = sub_compact->builder->NeedCompact();
+  if (s.ok() && sub_compact->context) {
+    s = sub_compact->context->UpdateMeta(&meta);
+  }
   if (s.ok()) {
     s = sub_compact->builder->Finish();
   } else {
@@ -824,8 +827,8 @@ Status CompactionJob::FinishCompactionOutputFile(
   }
 
   const uint64_t current_total_bytes = sub_compact->builder->TotalFileSize();
-  meta->fd.total_file_size = current_total_bytes;
-  meta->fd.base_file_size = sub_compact->builder->BaseFileSize();
+  meta.fd.total_file_size = current_total_bytes;
+  meta.fd.base_file_size = sub_compact->builder->BaseFileSize();
   sub_compact->current_output()->finished = true;
   sub_compact->total_bytes += current_total_bytes;
 
@@ -839,7 +842,7 @@ Status CompactionJob::FinishCompactionOutputFile(
     // Verify that the table is usable
     ColumnFamilyData* cfd = sub_compact->compaction->column_family_data();
     InternalIterator* iter = cfd->table_cache()->NewIterator(
-        ReadOptions(), env_options_, cfd->internal_comparator(), meta->fd, meta->UserFilter(),
+        ReadOptions(), env_options_, cfd->internal_comparator(), meta.fd, meta.UserFilter(),
         nullptr, cfd->internal_stats()->GetFileReadHist(
                      compact_->compaction->output_level()),
         false);
@@ -859,29 +862,29 @@ Status CompactionJob::FinishCompactionOutputFile(
       info.db_name = dbname_;
       info.cf_name = cfd->GetName();
       info.file_path =
-          TableFileName(cfd->ioptions()->db_paths, meta->fd.GetNumber(),
-                        meta->fd.GetPathId());
-      info.file_size = meta->fd.GetTotalFileSize();
+          TableFileName(cfd->ioptions()->db_paths, meta.fd.GetNumber(),
+                        meta.fd.GetPathId());
+      info.file_size = meta.fd.GetTotalFileSize();
       info.job_id = job_id_;
       RLOG(InfoLogLevel::INFO_LEVEL, db_options_.info_log,
           "[%s] [JOB %d] Generated table #%" PRIu64 ": %" PRIu64
           " keys, %" PRIu64 " bytes%s %s",
           cfd->GetName().c_str(), job_id_, output_number, current_entries,
           current_total_bytes,
-          meta->marked_for_compaction ? " (need compaction)" : "",
-          meta->FrontiersToString().c_str());
+          meta.marked_for_compaction ? " (need compaction)" : "",
+          meta.FrontiersToString().c_str());
       EventHelpers::LogAndNotifyTableFileCreation(
-          event_logger_, cfd->ioptions()->listeners, meta->fd, info);
+          event_logger_, cfd->ioptions()->listeners, meta.fd, info);
     }
   }
 
   // Report new file to SstFileManagerImpl
   auto sfm =
       static_cast<SstFileManagerImpl*>(db_options_.sst_file_manager.get());
-  if (sfm && meta->fd.GetPathId() == 0) {
+  if (sfm && meta.fd.GetPathId() == 0) {
     ColumnFamilyData* cfd = sub_compact->compaction->column_family_data();
-    auto fn = TableFileName(cfd->ioptions()->db_paths, meta->fd.GetNumber(),
-                            meta->fd.GetPathId());
+    auto fn = TableFileName(cfd->ioptions()->db_paths, meta.fd.GetNumber(),
+                            meta.fd.GetPathId());
     RETURN_NOT_OK(sfm->OnAddFile(fn));
     if (is_split_sst) {
       RETURN_NOT_OK(sfm->OnAddFile(TableBaseToDataFileName(fn)));
diff --git a/src/yb/rocksdb/db/version_edit.cc b/src/yb/rocksdb/db/version_edit.cc
index f21e996aade2..517f1c335f45 100644
--- a/src/yb/rocksdb/db/version_edit.cc
+++ b/src/yb/rocksdb/db/version_edit.cc
@@ -162,7 +162,7 @@ Status DecodeBoundaryValues(BoundaryValuesExtractor* extractor,
   if (extractor != nullptr) {
     if (values.has_user_frontier()) {
       out->user_frontier = extractor->CreateFrontier();
-      out->user_frontier->FromPB(values.user_frontier());
+      RETURN_NOT_OK(out->user_frontier->FromPB(values.user_frontier()));
     }
     for (const auto &user_value : values.user_values()) {
       UserBoundaryValuePtr decoded;
@@ -292,7 +292,7 @@ Status VersionEdit::DecodeFrom(BoundaryValuesExtractor* extractor, const Slice&
     }
     if (pb.has_flushed_frontier()) {
       flushed_frontier_ = extractor->CreateFrontier();
-      flushed_frontier_->FromPB(pb.flushed_frontier());
+      RETURN_NOT_OK(flushed_frontier_->FromPB(pb.flushed_frontier()));
     }
   }
   if (pb.has_max_column_family()) {
diff --git a/src/yb/rocksdb/metadata.h b/src/yb/rocksdb/metadata.h
index 2639b2bf34cf..05faaa425d8d 100644
--- a/src/yb/rocksdb/metadata.h
+++ b/src/yb/rocksdb/metadata.h
@@ -133,7 +133,7 @@ class UserFrontier {
   bool Dominates(const UserFrontier& rhs, UpdateUserValueType update_type) const;
 
   virtual void FromOpIdPBDeprecated(const yb::OpIdPB& op_id) = 0;
-  virtual void FromPB(const google::protobuf::Any& pb) = 0;
+  virtual yb::Status FromPB(const google::protobuf::Any& pb) = 0;
 
   virtual ~UserFrontier() {}
 
diff --git a/src/yb/rocksdb/util/testutil.h b/src/yb/rocksdb/util/testutil.h
index e9a79933f891..750318ac92bc 100644
--- a/src/yb/rocksdb/util/testutil.h
+++ b/src/yb/rocksdb/util/testutil.h
@@ -748,10 +748,11 @@ class TestUserFrontier : public UserFrontier {
 
   void FromOpIdPBDeprecated(const yb::OpIdPB& op_id) override {}
 
-  void FromPB(const google::protobuf::Any& pb) override {
+  Status FromPB(const google::protobuf::Any& pb) override {
     UserBoundaryValuePB value;
     pb.UnpackTo(&value);
     value_ = value.tag();
+    return Status::OK();
   }
 
   Slice Filter() const override {
diff --git a/src/yb/tablet/tablet-harness.cc b/src/yb/tablet/tablet-harness.cc
index f3428483f4dc..866e3fc1ee5c 100644
--- a/src/yb/tablet/tablet-harness.cc
+++ b/src/yb/tablet/tablet-harness.cc
@@ -51,8 +51,8 @@ CHECKED_STATUS TabletHarness::Create(bool first_time) {
   RETURN_NOT_OK(fs_manager_->CheckAndOpenFileSystemRoots());
 
   auto table_info = std::make_shared<TableInfo>(
-      "YBTableTest", "test", "YBTableTest", options_.table_type, schema_, IndexMap(), boost::none,
-      0 /* schema_version */, partition.first);
+      Primary::kTrue, "YBTableTest", "test", "YBTableTest", options_.table_type, schema_,
+      IndexMap(), boost::none, 0 /* schema_version */, partition.first);
   auto metadata = VERIFY_RESULT(RaftGroupMetadata::TEST_LoadOrCreate(RaftGroupMetadataData {
     .fs_manager = fs_manager_.get(),
     .table_info = table_info,
diff --git a/src/yb/tablet/tablet.cc b/src/yb/tablet/tablet.cc
index 651ca1dfe0ba..91800f5d9fdd 100644
--- a/src/yb/tablet/tablet.cc
+++ b/src/yb/tablet/tablet.cc
@@ -356,13 +356,22 @@ class Tablet::RegularRocksDbListener : public rocksdb::EventListener {
         log_prefix_(log_prefix) {}
 
   void OnCompactionCompleted(rocksdb::DB* db, const rocksdb::CompactionJobInfo& ci) override {
+    auto& metadata = *CHECK_NOTNULL(tablet_.metadata());
     if (ci.is_full_compaction) {
-      auto& metadata = *CHECK_NOTNULL(tablet_.metadata());
       if (!metadata.has_been_fully_compacted()) {
         metadata.set_has_been_fully_compacted(true);
         ERROR_NOT_OK(metadata.Flush(), log_prefix_);
       }
     }
+    std::unordered_map<Uuid, SchemaVersion, UuidHash> table_id_to_min_schema_version;
+    for (const auto& file : db->GetLiveFilesMetaData()) {
+      if (!file.smallest.user_frontier) {
+        continue;
+      }
+      auto& smallest = down_cast<docdb::ConsensusFrontier&>(*file.smallest.user_frontier);
+      smallest.MakeExternalSchemaVersionsAtMost(&table_id_to_min_schema_version);
+    }
+    ERROR_NOT_OK(metadata.OldSchemaGC(table_id_to_min_schema_version), log_prefix_);
   }
 
  private:
@@ -768,7 +777,7 @@ Status Tablet::OpenKeyValueTablet() {
 }
 
 Result<docdb::CompactionSchemaPacking> Tablet::GetSchemaPacking(
-    const Uuid& uuid, uint32_t schema_version) {
+    const Uuid& uuid, SchemaVersion schema_version) {
   TableInfoPtr table_info;
   if (uuid.IsNil()) {
     table_info = metadata_->primary_table_info();
@@ -779,7 +788,7 @@ Result<docdb::CompactionSchemaPacking> Tablet::GetSchemaPacking(
     }
     table_info = *res;
   }
-  if (schema_version == std::numeric_limits<uint32_t>::max()) {
+  if (schema_version == std::numeric_limits<SchemaVersion>::max()) {
     // TODO(packed_row) Don't pick schema changed after retention interval.
     schema_version =  table_info->schema_version;
   }
@@ -1183,6 +1192,13 @@ Status Tablet::ApplyOperation(
         : docdb::ValueControlFields::kMaxTtl;
     frontiers_ptr->Largest().set_max_value_level_ttl_expiration_time(
         docdb::FileExpirationFromValueTTL(operation.hybrid_time(), ttl));
+    for (const auto& p : write_batch.table_schema_version()) {
+      // Since new frontiers does not contain schema version just add it there.
+      auto table_id = p.table_id().empty()
+          ? Uuid::Nil() : VERIFY_RESULT(Uuid::FromSlice(p.table_id()));
+      frontiers_ptr->Smallest().AddSchemaVersion(table_id, p.schema_version());
+      frontiers_ptr->Largest().AddSchemaVersion(table_id, p.schema_version());
+    }
   }
   return ApplyKeyValueRowOperations(
       batch_idx, write_batch, frontiers_ptr, hybrid_time, already_applied_to_regular_db);
@@ -1351,7 +1367,8 @@ Status Tablet::HandleRedisReadRequest(CoarseTimePoint deadline,
 }
 
 bool IsSchemaVersionCompatible(
-    uint32_t current_version, uint32_t request_version, bool compatible_with_previous_version) {
+    SchemaVersion current_version, SchemaVersion request_version,
+    bool compatible_with_previous_version) {
   if (request_version == current_version) {
     return true;
   }
diff --git a/src/yb/tablet/tablet_bootstrap-test.cc b/src/yb/tablet/tablet_bootstrap-test.cc
index a5dc359c6ffe..524b14bd4917 100644
--- a/src/yb/tablet/tablet_bootstrap-test.cc
+++ b/src/yb/tablet/tablet_bootstrap-test.cc
@@ -178,8 +178,8 @@ class BootstrapTest : public LogTestBase {
     std::pair<PartitionSchema, Partition> partition = CreateDefaultPartition(schema);
 
     auto table_info = std::make_shared<TableInfo>(
-        log::kTestTable, log::kTestNamespace, log::kTestTable, kTableType, schema, IndexMap(),
-        boost::none /* index_info */, 0 /* schema_version */, partition.first);
+        Primary::kTrue, log::kTestTable, log::kTestNamespace, log::kTestTable, kTableType, schema,
+        IndexMap(), boost::none /* index_info */, 0 /* schema_version */, partition.first);
     *meta = VERIFY_RESULT(RaftGroupMetadata::TEST_LoadOrCreate(RaftGroupMetadataData {
       .fs_manager = fs_manager_.get(),
       .table_info = table_info,
diff --git a/src/yb/tablet/tablet_metadata.cc b/src/yb/tablet/tablet_metadata.cc
index 7bf11d8a3605..656eef68cccc 100644
--- a/src/yb/tablet/tablet_metadata.cc
+++ b/src/yb/tablet/tablet_metadata.cc
@@ -90,6 +90,14 @@ using yb::consensus::MinimumOpId;
 namespace yb {
 namespace tablet {
 
+namespace {
+
+Result<Uuid> ParseCotableId(Primary primary, const TableId& table_id) {
+  return primary ? Uuid::Nil() : Uuid::FromHexString(table_id);
+}
+
+}
+
 const int64 kNoDurableMemStore = -1;
 const std::string kIntentsSubdir = "intents";
 const std::string kIntentsDBSuffix = ".intents";
@@ -104,19 +112,21 @@ TableInfo::TableInfo()
       index_map(std::make_unique<IndexMap>()) {
 }
 
-TableInfo::TableInfo(std::string table_id,
+TableInfo::TableInfo(Primary primary,
+                     std::string table_id_,
                      std::string namespace_name,
                      std::string table_name,
                      TableType table_type,
                      const Schema& schema,
                      const IndexMap& index_map,
                      const boost::optional<IndexInfo>& index_info,
-                     const uint32_t schema_version,
+                     const SchemaVersion schema_version,
                      PartitionSchema partition_schema)
-    : table_id(std::move(table_id)),
+    : table_id(std::move(table_id_)),
       namespace_name(std::move(namespace_name)),
       table_name(std::move(table_name)),
       table_type(table_type),
+      cotable_id(CHECK_RESULT(ParseCotableId(primary, table_id))),
       doc_read_context(std::make_unique<docdb::DocReadContext>(schema, schema_version)),
       index_map(std::make_unique<IndexMap>(index_map)),
       index_info(index_info ? new IndexInfo(*index_info) : nullptr),
@@ -128,11 +138,12 @@ TableInfo::TableInfo(const TableInfo& other,
                      const Schema& schema,
                      const IndexMap& index_map,
                      const std::vector<DeletedColumn>& deleted_cols,
-                     const uint32_t schema_version)
+                     const SchemaVersion schema_version)
     : table_id(other.table_id),
       namespace_name(other.namespace_name),
       table_name(other.table_name),
       table_type(other.table_type),
+      cotable_id(other.cotable_id),
       doc_read_context(schema_version != other.schema_version
           ? std::make_unique<docdb::DocReadContext>(
               *other.doc_read_context, schema, schema_version)
@@ -145,13 +156,29 @@ TableInfo::TableInfo(const TableInfo& other,
   this->deleted_cols.insert(this->deleted_cols.end(), deleted_cols.begin(), deleted_cols.end());
 }
 
+TableInfo::TableInfo(const TableInfo& other, SchemaVersion min_schema_version)
+    : table_id(other.table_id),
+      namespace_name(other.namespace_name),
+      table_name(other.table_name),
+      table_type(other.table_type),
+      cotable_id(other.cotable_id),
+      doc_read_context(std::make_unique<docdb::DocReadContext>(
+          *other.doc_read_context, std::min(min_schema_version, other.schema_version))),
+      index_map(std::make_unique<IndexMap>(*other.index_map)),
+      index_info(other.index_info ? new IndexInfo(*other.index_info) : nullptr),
+      schema_version(other.schema_version),
+      partition_schema(other.partition_schema),
+      deleted_cols(other.deleted_cols) {
+}
+
 TableInfo::~TableInfo() = default;
 
-Status TableInfo::LoadFromPB(const TableInfoPB& pb) {
+Status TableInfo::LoadFromPB(const TableId& primary_table_id, const TableInfoPB& pb) {
   table_id = pb.table_id();
   namespace_name = pb.namespace_name();
   table_name = pb.table_name();
   table_type = pb.table_type();
+  cotable_id = VERIFY_RESULT(ParseCotableId(Primary(primary_table_id == table_id), table_id));
 
   RETURN_NOT_OK(doc_read_context->LoadFromPB(pb));
   if (pb.has_index_info()) {
@@ -200,15 +227,13 @@ Status KvStoreInfo::LoadTablesFromPB(
   tables.clear();
   for (const auto& table_pb : pbs) {
     auto table_info = std::make_shared<TableInfo>();
-    RETURN_NOT_OK(table_info->LoadFromPB(table_pb));
+    RETURN_NOT_OK(table_info->LoadFromPB(primary_table_id, table_pb));
     if (table_info->table_id != primary_table_id) {
       // TODO(alex): cotable_id should be loaded from PB schema, do we need this section?
       if (table_pb.schema().table_properties().is_ysql_catalog_table()) {
-        Uuid cotable_id;
-        CHECK_OK(cotable_id.FromHexString(table_info->table_id));
         // TODO(#79): when adding for multiple KV-stores per Raft group support - check if we need
         // to set cotable ID.
-        table_info->doc_read_context->schema.set_cotable_id(cotable_id);
+        table_info->doc_read_context->schema.set_cotable_id(table_info->cotable_id);
       }
       // Colocation ID is already set in schema.
       // TODO(alex): We don't have this info when master starts up?
@@ -698,7 +723,7 @@ void RaftGroupMetadata::ToSuperBlockUnlocked(RaftGroupReplicaSuperBlockPB* super
 void RaftGroupMetadata::SetSchema(const Schema& schema,
                                   const IndexMap& index_map,
                                   const std::vector<DeletedColumn>& deleted_cols,
-                                  const uint32_t version,
+                                  const SchemaVersion version,
                                   const TableId& table_id) {
   DCHECK(schema.has_column_ids());
   std::lock_guard<MutexType> lock(data_mutex_);
@@ -713,8 +738,7 @@ void RaftGroupMetadata::SetSchema(const Schema& schema,
     if (schema.table_properties().is_ysql_catalog_table()) {
       // TODO(alex): cotable_id should be copied from original schema, do we need this section?
       //             Might be related to #5017, #6107
-      Uuid cotable_id;
-      CHECK_OK(cotable_id.FromHexString(target_table_id));
+      auto cotable_id = CHECK_RESULT(Uuid::FromHexString(target_table_id));
       new_table_info->doc_read_context->schema.set_cotable_id(cotable_id);
     }
     // Ensure colocation ID remains unchanged.
@@ -761,9 +785,11 @@ void RaftGroupMetadata::AddTable(const std::string& table_id,
                                  const IndexMap& index_map,
                                  const PartitionSchema& partition_schema,
                                  const boost::optional<IndexInfo>& index_info,
-                                 const uint32_t schema_version) {
+                                 const SchemaVersion schema_version) {
   DCHECK(schema.has_column_ids());
-  TableInfoPtr new_table_info = std::make_shared<TableInfo>(table_id,
+  Primary primary(table_id == primary_table_id_);
+  TableInfoPtr new_table_info = std::make_shared<TableInfo>(primary,
+                                                            table_id,
                                                             namespace_name,
                                                             table_name,
                                                             table_type,
@@ -772,13 +798,11 @@ void RaftGroupMetadata::AddTable(const std::string& table_id,
                                                             index_info,
                                                             schema_version,
                                                             partition_schema);
-  if (table_id != primary_table_id_) {
+  if (!primary) {
     if (schema.table_properties().is_ysql_catalog_table()) {
       // TODO(alex): cotable_id seems to be properly copied from schema, do we need this section?
       //             Might be related to #5017, #6107
-      Uuid cotable_id;
-      CHECK_OK(cotable_id.FromHexString(table_id));
-      new_table_info->doc_read_context->schema.set_cotable_id(cotable_id);
+      new_table_info->doc_read_context->schema.set_cotable_id(new_table_info->cotable_id);
     }
   }
   std::lock_guard<MutexType> lock(data_mutex_);
@@ -1016,6 +1040,35 @@ bool RaftGroupMetadata::CleanupRestorations(
   return result;
 }
 
+Status RaftGroupMetadata::OldSchemaGC(
+    const std::unordered_map<Uuid, SchemaVersion, UuidHash>& versions) {
+  bool need_flush = false;
+  {
+    std::lock_guard<MutexType> lock(data_mutex_);
+    for (const auto& [table_id, schema_version] : versions) {
+      auto it = table_id.IsNil() ? kv_store_.tables.find(primary_table_id_)
+                                 : kv_store_.tables.find(table_id.ToHexString());
+      if (it == kv_store_.tables.end()) {
+        YB_LOG_EVERY_N_SECS(WARNING, 1)
+            << "Unknown table during " << __func__ << ": " << table_id.ToString();
+        continue;
+      }
+      if (!it->second->doc_read_context->schema_packing_storage.HasVersionBelow(schema_version)) {
+        continue;
+      }
+      auto new_value = std::make_shared<TableInfo>(
+          *it->second, schema_version);
+      it->second = new_value;
+      need_flush = true;
+    }
+  }
+
+  if (!need_flush) {
+    return Status::OK();
+  }
+  return Flush();
+}
+
 std::string RaftGroupMetadata::GetSubRaftGroupWalDir(const RaftGroupId& raft_group_id) const {
   return JoinPathSegments(DirName(wal_dir_), MakeTabletDirName(raft_group_id));
 }
@@ -1157,7 +1210,7 @@ std::shared_ptr<IndexMap> RaftGroupMetadata::index_map(const TableId& table_id)
   return std::shared_ptr<IndexMap>(table_info, table_info->index_map.get());
 }
 
-uint32_t RaftGroupMetadata::schema_version(const TableId& table_id) const {
+SchemaVersion RaftGroupMetadata::schema_version(const TableId& table_id) const {
   DCHECK_NE(state_, kNotLoadedYet);
   const TableInfoPtr table_info =
       table_id.empty() ? primary_table_info() : CHECK_RESULT(GetTableInfo(table_id));
diff --git a/src/yb/tablet/tablet_metadata.h b/src/yb/tablet/tablet_metadata.h
index f59a0b98f51c..83e029b469f5 100644
--- a/src/yb/tablet/tablet_metadata.h
+++ b/src/yb/tablet/tablet_metadata.h
@@ -71,19 +71,21 @@ extern const std::string kIntentsSubdir;
 extern const std::string kIntentsDBSuffix;
 extern const std::string kSnapshotsDirSuffix;
 
-  // Table info.
+YB_STRONGLY_TYPED_BOOL(Primary);
+
 struct TableInfo {
   // Table id, name and type.
   std::string table_id;
   std::string namespace_name;
   std::string table_name;
   TableType table_type;
+  Uuid cotable_id; // table_id as Uuid
 
   // The table schema, secondary index map, index info (for index table only) and schema version.
   const std::unique_ptr<docdb::DocReadContext> doc_read_context;
   std::unique_ptr<IndexMap> index_map;
   std::unique_ptr<IndexInfo> index_info;
-  uint32_t schema_version = 0;
+  SchemaVersion schema_version = 0;
 
   // Partition schema of the table.
   PartitionSchema partition_schema;
@@ -98,23 +100,25 @@ struct TableInfo {
   uint32_t wal_retention_secs = 0;
 
   TableInfo();
-  TableInfo(std::string table_id,
+  TableInfo(Primary primary,
+            std::string table_id,
             std::string namespace_name,
             std::string table_name,
             TableType table_type,
             const Schema& schema,
             const IndexMap& index_map,
             const boost::optional<IndexInfo>& index_info,
-            uint32_t schema_version,
+            SchemaVersion schema_version,
             PartitionSchema partition_schema);
   TableInfo(const TableInfo& other,
             const Schema& schema,
             const IndexMap& index_map,
             const std::vector<DeletedColumn>& deleted_cols,
-            uint32_t schema_version);
+            SchemaVersion schema_version);
+  TableInfo(const TableInfo& other, SchemaVersion min_schema_version);
   ~TableInfo();
 
-  CHECKED_STATUS LoadFromPB(const TableInfoPB& pb);
+  CHECKED_STATUS LoadFromPB(const TableId& primary_table_id, const TableInfoPB& pb);
   void ToPB(TableInfoPB* pb) const;
 
   std::string ToString() const {
@@ -239,7 +243,7 @@ class RaftGroupMetadata : public RefCountedThreadSafe<RaftGroupMetadata> {
 
   std::shared_ptr<IndexMap> index_map(const TableId& table_id = "") const;
 
-  uint32_t schema_version(const TableId& table_id = "") const;
+  SchemaVersion schema_version(const TableId& table_id = "") const;
 
   const std::string& indexed_table_id(const TableId& table_id = "") const;
 
@@ -321,7 +325,7 @@ class RaftGroupMetadata : public RefCountedThreadSafe<RaftGroupMetadata> {
   void SetSchema(const Schema& schema,
                  const IndexMap& index_map,
                  const std::vector<DeletedColumn>& deleted_cols,
-                 const uint32_t version,
+                 const SchemaVersion version,
                  const TableId& table_id = "");
 
   void SetPartitionSchema(const PartitionSchema& partition_schema);
@@ -338,7 +342,7 @@ class RaftGroupMetadata : public RefCountedThreadSafe<RaftGroupMetadata> {
                 const IndexMap& index_map,
                 const PartitionSchema& partition_schema,
                 const boost::optional<IndexInfo>& index_info,
-                const uint32_t schema_version);
+                const SchemaVersion schema_version);
 
   void RemoveTable(const TableId& table_id);
 
@@ -451,6 +455,9 @@ class RaftGroupMetadata : public RefCountedThreadSafe<RaftGroupMetadata> {
 
   bool UsePartialRangeKeyIntents() const;
 
+  // versions is a map from table id to min schema version that should be kept for this table.
+  Status OldSchemaGC(const std::unordered_map<Uuid, SchemaVersion, UuidHash>& versions);
+
  private:
   typedef simple_spinlock MutexType;
 
diff --git a/src/yb/tablet/write_query.cc b/src/yb/tablet/write_query.cc
index 5cebc127d7c3..77bb01c6d6f8 100644
--- a/src/yb/tablet/write_query.cc
+++ b/src/yb/tablet/write_query.cc
@@ -26,6 +26,7 @@
 #include "yb/common/schema.h"
 
 #include "yb/docdb/conflict_resolution.h"
+#include "yb/docdb/consensus_frontier.h"
 #include "yb/docdb/cql_operation.h"
 #include "yb/docdb/doc_write_batch.h"
 #include "yb/docdb/packed_row.h"
@@ -278,6 +279,9 @@ Result<bool> WriteQuery::CqlPrepareExecute() {
   auto& metadata = *tablet().metadata();
   DVLOG(2) << "Schema version for  " << metadata.table_name() << ": " << metadata.schema_version();
 
+  docdb::AddTableSchemaVersion(
+      Uuid::Nil(), metadata.schema_version(), request().mutable_write_batch());
+
   const auto& ql_write_batch = client_request_->ql_write_batch();
 
   doc_ops_.reserve(ql_write_batch.size());
@@ -355,6 +359,8 @@ Result<bool> WriteQuery::PgsqlPrepareExecute() {
                  table_info->schema_version,
                  req.schema_version()));
     } else {
+      docdb::AddTableSchemaVersion(
+          table_info->cotable_id, table_info->schema_version, request().mutable_write_batch());
       if (doc_ops_.empty()) {
         // Use the value of is_ysql_catalog_table from the first operation in the batch.
         txn_op_ctx = VERIFY_RESULT(tablet().CreateTransactionOperationContext(
@@ -364,7 +370,7 @@ Result<bool> WriteQuery::PgsqlPrepareExecute() {
       }
       auto write_op = std::make_unique<docdb::PgsqlWriteOperation>(
           req,
-          *table_info->doc_read_context.get(),
+          *table_info->doc_read_context,
           txn_op_ctx);
       RETURN_NOT_OK(write_op->Init(resp));
       doc_ops_.emplace_back(std::move(write_op));
diff --git a/src/yb/tserver/mini_tablet_server.cc b/src/yb/tserver/mini_tablet_server.cc
index 4267a775513d..cdc9c8a072f7 100644
--- a/src/yb/tserver/mini_tablet_server.cc
+++ b/src/yb/tserver/mini_tablet_server.cc
@@ -305,7 +305,7 @@ Status MiniTabletServer::AddTestTablet(const std::string& ns_id,
   pair<PartitionSchema, Partition> partition = tablet::CreateDefaultPartition(schema_with_ids);
 
   auto table_info = std::make_shared<tablet::TableInfo>(
-      table_id, ns_id, table_id, table_type, schema_with_ids, IndexMap(),
+      tablet::Primary::kTrue, table_id, ns_id, table_id, table_type, schema_with_ids, IndexMap(),
       boost::none /* index_info */, 0 /* schema_version */, partition.first);
 
   return ResultToStatus(server_->tablet_manager()->CreateNewTablet(
diff --git a/src/yb/tserver/remote_bootstrap_client.cc b/src/yb/tserver/remote_bootstrap_client.cc
index dd64bed900da..a90df9fbdffc 100644
--- a/src/yb/tserver/remote_bootstrap_client.cc
+++ b/src/yb/tserver/remote_bootstrap_client.cc
@@ -341,8 +341,8 @@ Status RemoteBootstrapClient::Start(const string& bootstrap_peer_uuid,
                                               &wal_root_dir);
     }
     auto table_info = std::make_shared<tablet::TableInfo>(
-        table_id, table.namespace_name(), table.table_name(), table.table_type(), schema,
-        IndexMap(table.indexes()),
+        tablet::Primary::kTrue, table_id, table.namespace_name(), table.table_name(),
+        table.table_type(), schema, IndexMap(table.indexes()),
         table.has_index_info() ? boost::optional<IndexInfo>(table.index_info()) : boost::none,
         table.schema_version(), partition_schema);
     fs_manager().SetTabletPathByDataPath(tablet_id_, data_root_dir);
diff --git a/src/yb/tserver/tablet_server-test.cc b/src/yb/tserver/tablet_server-test.cc
index eaf879dc0684..8adb3411c12e 100644
--- a/src/yb/tserver/tablet_server-test.cc
+++ b/src/yb/tserver/tablet_server-test.cc
@@ -812,8 +812,8 @@ TEST_F(TabletServerTest, TestWriteOutOfBounds) {
 
   Partition partition;
   auto table_info = std::make_shared<tablet::TableInfo>(
-      "TestWriteOutOfBoundsTable", "test_ns", tabletId, YQL_TABLE_TYPE, schema, IndexMap(),
-      boost::none /* index_info */, 0 /* schema_version */, partition_schema);
+      tablet::Primary::kTrue, "TestWriteOutOfBoundsTable", "test_ns", tabletId, YQL_TABLE_TYPE,
+      schema, IndexMap(), boost::none /* index_info */, 0 /* schema_version */, partition_schema);
   ASSERT_OK(mini_server_->server()->tablet_manager()->CreateNewTablet(
       table_info, tabletId, partition, mini_server_->CreateLocalConfig()));
 
diff --git a/src/yb/tserver/tablet_service.cc b/src/yb/tserver/tablet_service.cc
index 5fa6991d5837..efc957149c7a 100644
--- a/src/yb/tserver/tablet_service.cc
+++ b/src/yb/tserver/tablet_service.cc
@@ -1262,8 +1262,8 @@ Status TabletServiceAdminImpl::DoCreateTablet(const CreateTabletRequestPB* req,
   VLOG(1) << "Full request: " << req->DebugString();
 
   auto table_info = std::make_shared<tablet::TableInfo>(
-      req->table_id(), req->namespace_name(), req->table_name(), req->table_type(), schema,
-      IndexMap(),
+      tablet::Primary::kTrue, req->table_id(), req->namespace_name(), req->table_name(),
+      req->table_type(), schema, IndexMap(),
       req->has_index_info() ? boost::optional<IndexInfo>(req->index_info()) : boost::none,
       0 /* schema_version */, partition_schema);
   std::vector<SnapshotScheduleId> snapshot_schedules;
diff --git a/src/yb/tserver/ts_tablet_manager-test.cc b/src/yb/tserver/ts_tablet_manager-test.cc
index edaec913786f..0f2c33be372e 100644
--- a/src/yb/tserver/ts_tablet_manager-test.cc
+++ b/src/yb/tserver/ts_tablet_manager-test.cc
@@ -156,8 +156,9 @@ class TsTabletManagerTest : public YBTest {
     std::pair<PartitionSchema, Partition> partition = tablet::CreateDefaultPartition(full_schema);
 
     auto table_info = std::make_shared<tablet::TableInfo>(
-        table_id, tablet_id, tablet_id, TableType::DEFAULT_TABLE_TYPE, full_schema, IndexMap(),
-        boost::none /* index_info */, 0 /* schema_version */, partition.first);
+        tablet::Primary::kTrue, table_id, tablet_id, tablet_id, TableType::DEFAULT_TABLE_TYPE,
+        full_schema, IndexMap(), boost::none /* index_info */, 0 /* schema_version */,
+        partition.first);
     auto tablet_peer = VERIFY_RESULT(tablet_manager_->CreateNewTablet(
         table_info, tablet_id, partition.second, config_));
     if (out_tablet_peer) {
diff --git a/src/yb/util/type_traits.h b/src/yb/util/type_traits.h
index ef43a0c130c1..d8b147ad332e 100644
--- a/src/yb/util/type_traits.h
+++ b/src/yb/util/type_traits.h
@@ -66,10 +66,12 @@ class IsPointerLikeHelper {
   typedef int Yes;
   typedef struct { Yes array[2]; } No;
 
-  template <typename C> static Yes HasDeref(decltype(&C::operator*));
+  template <typename C> static Yes HasDeref(
+      typename std::remove_reference<decltype(*std::declval<C>())>::type*);
   template <typename C> static No HasDeref(...);
 
-  template <typename C> static Yes HasArrow(decltype(&C::operator->));
+  template <typename C> static Yes HasArrow(
+      typename std::remove_reference<decltype(std::declval<C>().operator->())>::type*);
   template <typename C> static No HasArrow(...);
  public:
   typedef boost::mpl::bool_<sizeof(HasDeref<T>(nullptr)) == sizeof(Yes) &&
diff --git a/src/yb/util/uuid-test.cc b/src/yb/util/uuid-test.cc
index 77569fa7a092..4e627f961f8b 100644
--- a/src/yb/util/uuid-test.cc
+++ b/src/yb/util/uuid-test.cc
@@ -26,8 +26,7 @@ class UuidTest : public YBTest {
     Uuid uuid_orig = ASSERT_RESULT(Uuid::FromString(strval));
     std::string bytes;
     uuid_orig.ToBytes(&bytes);
-    Uuid uuid_new;
-    ASSERT_OK(uuid_new.FromBytes(bytes));
+    Uuid uuid_new = ASSERT_RESULT(Uuid::FromSlice(bytes));
 
     // Test encode and decode.
     std::string encoded_bytes;
@@ -150,24 +149,18 @@ TEST_F(UuidTest, TestErrors) {
   ASSERT_TRUE(empty_uuid.ok());
   ASSERT_EQ(*empty_uuid, Uuid::Nil());
 
-  Uuid uuid;
-  std::string bytes;
-  ASSERT_FALSE(uuid.FromBytes(bytes).ok());
-  bytes = "0";
-  ASSERT_FALSE(uuid.FromBytes(bytes).ok());
-  bytes = "012345";
-  ASSERT_FALSE(uuid.FromBytes(bytes).ok());
-  bytes = "111111111111111111"; // 17 bytes.
-  ASSERT_FALSE(uuid.FromBytes(bytes).ok());
+  ASSERT_NOK(Uuid::FromSlice(""));
+  ASSERT_NOK(Uuid::FromSlice("0"));
+  ASSERT_NOK(Uuid::FromSlice("012345"));
+  ASSERT_NOK(Uuid::FromSlice("111111111111111111")); // 17 bytes.
 
   // Test hex string
-  ASSERT_FALSE(uuid.FromHexString("123").ok());
-  ASSERT_FALSE(uuid.FromHexString("zz111111111111111111111111111111").ok());
+  ASSERT_NOK(Uuid::FromHexString("123"));
+  ASSERT_NOK(Uuid::FromHexString("zz111111111111111111111111111111"));
 }
 
 Result<Uuid> HexRoundTrip(const std::string& input) {
-  Uuid uuid;
-  RETURN_NOT_OK(uuid.FromHexString(input));
+  auto uuid = VERIFY_RESULT(Uuid::FromHexString(input));
   EXPECT_EQ(input, uuid.ToHexString());
   return uuid;
 }
diff --git a/src/yb/util/uuid.cc b/src/yb/util/uuid.cc
index eb29da337575..01f9c5c0ac3a 100644
--- a/src/yb/util/uuid.cc
+++ b/src/yb/util/uuid.cc
@@ -98,21 +98,13 @@ Slice Uuid::AsSlice() const {
   return Slice(boost_uuid_.data, boost_uuid_.size());
 }
 
-CHECKED_STATUS Uuid::FromSlice(const Slice& slice, size_t size_hint) {
-  size_t expected_size = (size_hint == 0) ? slice.size() : size_hint;
-  if (expected_size > slice.size()) {
-    return STATUS_SUBSTITUTE(InvalidArgument, "Size of slice: $0 is smaller than provided "
-        "size_hint: $1", slice.size(), expected_size);
-  }
-  if (expected_size != kUuidSize) {
-    return STATUS_SUBSTITUTE(InvalidArgument, "Size of slice is invalid: $0", expected_size);
+Result<Uuid> Uuid::FromSlice(const Slice& slice) {
+  if (slice.size() != kUuidSize) {
+    return STATUS_SUBSTITUTE(InvalidArgument, "Size of slice is invalid: $0", slice.size());
   }
-  memcpy(boost_uuid_.data, slice.data(), kUuidSize);
-  return Status::OK();
-}
-
-CHECKED_STATUS Uuid::FromBytes(const std::string& bytes) {
-  return FromSlice(Slice(bytes.data(), bytes.size()));
+  Uuid result;
+  memcpy(result.boost_uuid_.data, slice.data(), kUuidSize);
+  return result;
 }
 
 std::string Uuid::ToHexString() const {
@@ -130,7 +122,7 @@ std::string Uuid::ToHexString() const {
   return std::string(buffer, sizeof(buffer) - 1);
 }
 
-CHECKED_STATUS Uuid::FromHexString(const std::string& hex_string) {
+Result<Uuid> Uuid::FromHexString(const std::string& hex_string) {
   constexpr size_t kInputLen = kUuidSize * 2;
   if (hex_string.length() != kInputLen) {
     return STATUS_SUBSTITUTE(InvalidArgument, "Size of hex_string is invalid: $0, expected: $1",
@@ -142,6 +134,7 @@ CHECKED_STATUS Uuid::FromHexString(const std::string& hex_string) {
   char buffer[kWordLen + 1];
   buffer[kWordLen] = 0;
 
+  Uuid result;
   for (size_t i = 0; i != kInputLen;) {
     memcpy(buffer, hex_string.c_str() + i, kWordLen);
     char* endptr = nullptr;
@@ -153,10 +146,10 @@ CHECKED_STATUS Uuid::FromHexString(const std::string& hex_string) {
     static_assert(sizeof(Word) == 8, "Adjust little endian conversion below");
     value = LittleEndian::FromHost64(value);
     i += kWordLen;
-    memcpy(boost_uuid_.data + boost_uuid_.size() - i / 2, &value, sizeof(value));
+    memcpy(result.boost_uuid_.data + result.boost_uuid_.size() - i / 2, &value, sizeof(value));
   }
 
-  return Status::OK();
+  return result;
 }
 
 CHECKED_STATUS Uuid::DecodeFromComparableSlice(const Slice& slice, size_t size_hint) {
diff --git a/src/yb/util/uuid.h b/src/yb/util/uuid.h
index 5fe9774da13a..b6c5975172e9 100644
--- a/src/yb/util/uuid.h
+++ b/src/yb/util/uuid.h
@@ -19,8 +19,10 @@
 #include <array>
 #include <random>
 
+#include <boost/functional/hash.hpp>
 #include <boost/uuid/uuid.hpp>
 
+#include "yb/util/cast.h"
 #include "yb/util/status_fwd.h"
 
 namespace yb {
@@ -89,13 +91,9 @@ class Uuid {
     bytes->append(reinterpret_cast<char *>(output), kUuidSize);
   }
 
-  // Given a string holding the raw bytes in network byte order, it builds the appropriate
-  // UUID object.
-  CHECKED_STATUS FromBytes(const std::string& bytes);
-
   // Given a string representation of uuid in hex where the bytes are in host byte order, build
   // an appropriate UUID object.
-  CHECKED_STATUS FromHexString(const std::string& hex_string);
+  static Result<Uuid> FromHexString(const std::string& hex_string);
 
   std::string ToHexString() const;
 
@@ -104,7 +102,7 @@ class Uuid {
 
   // Give a slice holding raw bytes in network byte order, build the appropriate UUID
   // object. If size_hint is specified, it indicates the number of bytes to decode from the slice.
-  CHECKED_STATUS FromSlice(const Slice& slice, size_t size_hint = 0);
+  static Result<Uuid> FromSlice(const Slice& slice);
 
   CHECKED_STATUS DecodeFromComparableSlice(const Slice& slice, size_t size_hint = 0);
 
@@ -172,6 +170,10 @@ class Uuid {
     return boost_uuid_.data;
   }
 
+  const char* cdata() const {
+    return pointer_cast<const char*>(data());
+  }
+
   size_t size() const {
     return boost_uuid_.size();
   }
@@ -267,6 +269,12 @@ class Uuid {
 
 };
 
+inline size_t hash_value(const Uuid& uuid) {
+  return hash_value(uuid.impl());
+}
+
+using UuidHash = boost::hash<Uuid>;
+
 } // namespace yb
 
 #endif // YB_UTIL_UUID_H
diff --git a/src/yb/yql/cql/cqlserver/cql_processor.cc b/src/yb/yql/cql/cqlserver/cql_processor.cc
index 3e0f99fc9118..5fcd5d18a1af 100644
--- a/src/yb/yql/cql/cqlserver/cql_processor.cc
+++ b/src/yb/yql/cql/cqlserver/cql_processor.cc
@@ -889,7 +889,7 @@ unique_ptr<CQLResponse> CQLProcessor::ProcessAuthResult(const string& saved_hash
     if (!ldap_auth_result.ok()) {
       return make_unique<ErrorResponse>(
           *request_, ErrorResponse::Code::SERVER_ERROR,
-          "Failed to authenticate using LDAP: " + yb::ToString(ldap_auth_result));
+          "Failed to authenticate using LDAP: " + ldap_auth_result.status().ToString());
     } else if (!*ldap_auth_result) {
       response = make_unique<ErrorResponse>(
           *request_, ErrorResponse::Code::BAD_CREDENTIALS,
diff --git a/src/yb/yql/pgwrapper/pg_packed_row-test.cc b/src/yb/yql/pgwrapper/pg_packed_row-test.cc
index a0acb23fed4a..290b4c20b839 100644
--- a/src/yb/yql/pgwrapper/pg_packed_row-test.cc
+++ b/src/yb/yql/pgwrapper/pg_packed_row-test.cc
@@ -11,7 +11,12 @@
 // under the License.
 //
 
+#include "yb/docdb/doc_read_context.h"
+
+#include "yb/rocksdb/db/db_impl.h"
+
 #include "yb/tablet/tablet.h"
+#include "yb/tablet/tablet_metadata.h"
 #include "yb/tablet/tablet_peer.h"
 
 #include "yb/yql/pgwrapper/pg_mini_test_base.h"
@@ -33,7 +38,7 @@ class PgPackedRowTest : public PgMiniTestBase {
   }
 };
 
-TEST_F(PgPackedRowTest, YB_DISABLE_TEST_IN_TSAN(PackedRow)) {
+TEST_F(PgPackedRowTest, YB_DISABLE_TEST_IN_TSAN(Simple)) {
   auto conn = ASSERT_RESULT(Connect());
 
   ASSERT_OK(conn.Execute("CREATE TABLE t (key INT PRIMARY KEY, v1 TEXT, v2 TEXT)"));
@@ -54,7 +59,7 @@ TEST_F(PgPackedRowTest, YB_DISABLE_TEST_IN_TSAN(PackedRow)) {
   ASSERT_EQ(value, "four, five");
 }
 
-TEST_F(PgPackedRowTest, YB_DISABLE_TEST_IN_TSAN(RandomPackedRow)) {
+TEST_F(PgPackedRowTest, YB_DISABLE_TEST_IN_TSAN(Random)) {
   constexpr int kModifications = 4000;
   constexpr int kKeys = 50;
 
@@ -144,7 +149,7 @@ TEST_F(PgPackedRowTest, YB_DISABLE_TEST_IN_TSAN(RandomPackedRow)) {
   }
 }
 
-TEST_F(PgPackedRowTest, YB_DISABLE_TEST_IN_TSAN(PackedRowSchemaChange)) {
+TEST_F(PgPackedRowTest, YB_DISABLE_TEST_IN_TSAN(SchemaChange)) {
   constexpr int kKey = 10;
   constexpr int kValue1 = 10;
 
@@ -168,5 +173,80 @@ TEST_F(PgPackedRowTest, YB_DISABLE_TEST_IN_TSAN(PackedRowSchemaChange)) {
   ASSERT_EQ(value, "");
 }
 
+// Check that we GC old schemas. I.e. when there are no more packed rows with this schema version.
+TEST_F(PgPackedRowTest, YB_DISABLE_TEST_IN_TSAN(SchemaGC)) {
+  constexpr int kModifications = 1200;
+
+  auto conn = ASSERT_RESULT(Connect());
+  std::map<int, int> columns; // Active columns. Maps to step when column was added.
+  int next_column_idx = 0;
+
+  std::mt19937_64 rng(42);
+
+  ASSERT_OK(conn.Execute("CREATE TABLE t (key INT PRIMARY KEY) SPLIT INTO 1 TABLETS"));
+
+  for (int i = 1; i <= kModifications; ++i) {
+    auto alter_schema = i % 25 == 0;
+    auto last_iteration = i == kModifications;
+    if (alter_schema) {
+      if (columns.empty() || RandomUniformBool(&rng)) {
+        columns.emplace(++next_column_idx, i);
+        ASSERT_OK(conn.ExecuteFormat("ALTER TABLE t ADD COLUMN v$0 INT", next_column_idx));
+      } else {
+        auto it = columns.begin();
+        std::advance(it, RandomUniformInt<size_t>(0, columns.size() - 1));
+        ASSERT_OK(conn.ExecuteFormat("ALTER TABLE t DROP COLUMN v$0", it->first));
+        columns.erase(it);
+      }
+    }
+
+    std::string expr = "INSERT INTO t (key";
+    std::string values = std::to_string(i);
+    for (const auto& p : columns) {
+      expr += Format(", v$0", p.first);
+      values += Format(", $0", p.first * kModifications + i);
+    }
+    expr += ") VALUES (";
+    expr += values;
+    expr += ")";
+    ASSERT_OK(conn.Execute(expr));
+
+    if (i % 100 == 0 || last_iteration) {
+      ASSERT_OK(cluster_->FlushTablets(tablet::FlushMode::kSync));
+      if (i % 400 == 0 || last_iteration) {
+        ASSERT_OK(cluster_->CompactTablets());
+      }
+    }
+
+    if (alter_schema || last_iteration) {
+      auto res = ASSERT_RESULT(conn.FetchMatrix(
+          "SELECT * FROM t", i, narrow_cast<int>(columns.size() + 1)));
+      for (int row = 0; row != i; ++row) {
+        int key = ASSERT_RESULT(GetValue<int>(res.get(), row, 0));
+        int idx = 0;
+        for (const auto& p : columns) {
+          auto is_null = PQgetisnull(res.get(), row, ++idx);
+          ASSERT_EQ(is_null, key < p.second);
+          if (is_null) {
+            continue;
+          }
+          auto value = ASSERT_RESULT(GetValue<int>(res.get(), row, idx));
+          ASSERT_EQ(value, p.first * kModifications + key);
+        }
+      }
+    }
+  }
+
+  auto peers = ListTabletPeers(cluster_.get(), ListPeersFilter::kAll);
+  for (const auto& peer : peers) {
+    if (peer->table_type() == TableType::TRANSACTION_STATUS_TABLE_TYPE) {
+      continue;
+    }
+    auto files = peer->tablet()->doc_db().regular->GetLiveFilesMetaData();
+    auto table_info = peer->tablet_metadata()->primary_table_info();
+    ASSERT_EQ(table_info->doc_read_context->schema_packing_storage.SchemaCount(), 1);
+  }
+}
+
 } // namespace pgwrapper
 } // namespace yb
